// FILE: ./assets/js/repositories/Bco51100_TipodeDebitoBancario_Repository.js
function Bco51100_TipodeDebitoBancario_Repository(restEngine) {

	this.validarCodigo = function(row){
	    return restEngine.post("cadFin#/tpdebibanc/validarCodigo", {
            "requestType": "Row",
            "row": row 
        });
	};

}

Configuration(function (ContextRegister) {
	ContextRegister.register('Bco51100_TipodeDebitoBancario_Repository', Bco51100_TipodeDebitoBancario_Repository);
});

// FILE: ./assets/js/repositories/Bco51200_TipoCreditoBancario_Repository.js
function Bco51200_TipoDeCreditoBancario_Repository(restEngine) {

	this.validarCodigo = function(row){
	    return restEngine.post("cadFin#/tpcredbanc/validarCodigo", {
            "requestType": "Row",
            "row": row 
        });
	};

}

Configuration(function (ContextRegister) {
	ContextRegister.register('Bco51200_TipoDeCreditoBancario_Repository', Bco51200_TipoDeCreditoBancario_Repository);
});

// FILE: ./assets/js/repositories/Ger03000_historicoIntegracao_Repository.js
var Ger03000_historicoIntegracao_Repository = function(restEngine){
	this.salvar = function(data){
		return restEngine.post('cadFin#/crud/histintegra_histpadr/save', {
            "requestType": "DataSet",
            "dataset": data
        });
	};

    this.find = function(){
        return restEngine.post('cadFin#/crud/histintegra_histpadr', {
            "requestType": "FilterData",
            "filter": []
        });
    };
};
Configuration(function (ContextRegister){
    ContextRegister.register('Ger03000_historicoIntegracao_Repository', Ger03000_historicoIntegracao_Repository);
});

// FILE: ./assets/js/repositories/Ger06700_FormaPagamento_Repository.js
var Ger06700_FormaPagamento_Repository = function(restEngine, localStorageEngine){

    this.getPeriodo = function(cdformpgto, nrorg) {
        var filter = [
            {
                "name": "CDFORMPGTO",
                "operator": "=",
                "value": cdformpgto
            },
            {
                "name": "NRORG",
                "operator": "=",
                "value": nrorg
            }
        ];
        
        return restEngine.post('cadFin#/crud/diapgto', {
            "requestType": "FilterData",
            "filter": filter
        });
    };

	this.excluiPeriodo = function(row) {
        return restEngine.post('cadFin#/crud/diapgto/remove', {
            "requestType": "Row",
            "row": row
        });
    };
    
};
 Configuration(function (ContextRegister){
    ContextRegister.register('Ger06700_FormaPagamento_Repository', Ger06700_FormaPagamento_Repository);
});

// FILE: ./assets/js/repositories/Ger08300_banco_Repository.js
function Ger08300_banco_Repository(restEngine) {

	this.save = function(row) {
        return restEngine.post('cadFin#/empresa_cnab/save', {
            "requestType": "Row",
            "row": row
        });
	};
}

Configuration(function (ContextRegister) {
	ContextRegister.register('Ger08300_banco_Repository', Ger08300_banco_Repository);
});

// FILE: ./assets/js/repositories/Ger08500_ContaCorrente_Repository.js
function Ger08500_ContaCorrente_Repository(restEngine, localStorageEngine) {
	this.retornaUnidadeLogada = function() {
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": "FILIAL_LOGADA"
            }
        ];
        return localStorageEngine.download("cadFin#/crud/filial", filter);
    };
	this.recalculaValor = function(row) {
        return restEngine.post('cadFin#/recalcularValor', {
            "requestType": "Row",
            "row": row
        });
	};
	this.validarContaCorrente = function(row) {
        return restEngine.post('cadFin#/contcorr/validarContaCorrente', {
            "requestType": "Row",
            "row": row
        });
	};
}

Configuration(function (ContextRegister) {
	ContextRegister.register('Ger08500_ContaCorrente_Repository', Ger08500_ContaCorrente_Repository);
});

// FILE: ./assets/js/repositories/Ger25940_TipoRecebimento_Repository.js
var Ger25940_TipoRecebimento_Repository = function(restEngine, localStorageEngine){

	this.verificaRecebimentos = function(){
        return restEngine.post('cadFin#/tiporece_tiporece', {
            "requestType": "FilterData",
            "filter": ""
        });
    };
};
 Configuration(function (ContextRegister){
    ContextRegister.register('Ger25940_TipoRecebimento_Repository', Ger25940_TipoRecebimento_Repository);
});

// FILE: ./assets/js/repositories/rec41100_TipoContaReceber_Repository.js
var rec41100_TipoContaReceber_Repository = function(restEngine) {
  
  this.getContctblMask = function() {
    return restEngine.post("cadFin#/crud/paramgeral", {
                    "requestType": "FilterData", 
                    "filter": []});
  }; 
  
  this.getNvMaxContctbl = function() {
    return restEngine.post("cadFin#/tipoctreceber_classfinanc_contctbl/nvmax_contctbl", {
                      "requestType": "FilterData",
                      "filter": []});
  };
  
};

Configuration(function(ContextRegister) {
  ContextRegister.register("rec41100_TipoContaReceber_Repository", rec41100_TipoContaReceber_Repository);
});

// FILE: ./assets/js/services/Bco51100_TipodeDebitoBancario_Service.js
function Bco51100_TipodeDebitoBancario_Service(Bco51100_TipodeDebitoBancario_Repository) {

	this.validarCodigo = function(row){
	    return Bco51100_TipodeDebitoBancario_Repository.validarCodigo(row);
	}; 

}

Configuration(function (ContextRegister) {
	ContextRegister.register('Bco51100_TipodeDebitoBancario_Service', Bco51100_TipodeDebitoBancario_Service);
});

// FILE: ./assets/js/services/Bco51200_TipoCreditoBancario_Service.js
function Bco51200_TipoDeCreditoBancario_Service(Bco51200_TipoDeCreditoBancario_Repository) {

	this.validarCodigo = function(row){
	    return Bco51200_TipoDeCreditoBancario_Repository.validarCodigo(row);
	}; 

}

Configuration(function (ContextRegister) {
	ContextRegister.register('Bco51200_TipoDeCreditoBancario_Service', Bco51200_TipoDeCreditoBancario_Service);
});

// FILE: ./assets/js/services/Ger01600_IndiceFinanceiro_Service.js
var Ger01600_IndiceFinanceiro_Service = function(restEngine, localStorageEngine) {
	this.maxDtrefind = function(filter) {
        return restEngine.post('/max_dtrefind', {
            "requestType": "FilterData",
            "filter": filter
        });
    };
    this.minDtrefind = function(filter) {
        return restEngine.post('/min_dtrefind', {
            "requestType": "FilterData",
            "filter": filter
        });
    };
    this.saveMovindice = function(data) {
        return restEngine.post('cadFin#/crud/movindice/save', {
            "requestType": "DataSet",
            "dataset": data
        });
    };
    this.deleteMovindice = function(data) {
        return restEngine.post('cadFin#/crud/movindice/remove', {
            "requestType": "DataSet",
            "dataset": data
        });
    };

    this.deleteIndice = function(data){
        var dataSave =[];
        dataSave.push(data);
        return restEngine.post('/indice/remove', {
            "requestType": "DataSet",
            "dataset": dataSave
        });
    };
};
Configuration(function(ContextRegister) {
	ContextRegister.register("Ger01600_IndiceFinanceiro_Service", Ger01600_IndiceFinanceiro_Service);
});


// FILE: ./assets/js/services/Ger03000_historicoIntegracao_Service.js
var Ger03000_historicoIntegracao_Service = function(ScreenService, Ger03000_historicoIntegracao_Repository){
	this.insertInit = function(){
		return Ger03000_historicoIntegracao_Repository.find().then(function(banco){
			var consulta = banco.dataset.histintegra_histpadr;
			var row = [
				{
					__is_new : true,
					CDOPERACAO : 'CTAPAG'
				},
				{
					__is_new : true,
					CDOPERACAO : 'BAIXAP'
				},
				{
					__is_new : true,
					CDOPERACAO : 'CTAREC'
				},
				{
					__is_new : true,
					CDOPERACAO : 'BAIXAR'
				},
				{
					__is_new : true,
					CDOPERACAO : 'TRANSF'
				},
				{
					__is_new : true,
					CDOPERACAO : 'BXPADI'
				}
			];
			for(var i = 0; i < consulta.length; i++){
				var codigo = consulta[i].CDOPERACAO;
				if(codigo == 'CTAPAG'||codigo == 'BAIXAP'||codigo == 'CTAREC' || codigo == 'BAIXAR'||codigo == 'TRANSF'||codigo == 'BXPADI'){
					for(var j = 0; j < row.length; j++){
			   			if(codigo === row[j].CDOPERACAO){
			   				row.splice(j, 1);
			   				j = row.length - 1;
			   				if(!row[0]){
			   					i = consulta.length -1;
			   				}
			   			}
					}
				}
			}
			if(row[0]){
				return Ger03000_historicoIntegracao_Repository.salvar(row);
			}
		});
	};
};
Configuration(function (ContextRegister){
    ContextRegister.register('Ger03000_historicoIntegracao_Service', Ger03000_historicoIntegracao_Service);
});

// FILE: ./assets/js/services/Ger06700_FormaPagamento_Service.js
var Ger06700_FormaPagamento_Service = function(Ger06700_FormaPagamento_Repository){

    this.getPeriodo = function(cdformpgto, nrorg) {
        return Ger06700_FormaPagamento_Repository.getPeriodo(cdformpgto, nrorg);
    };
 
	this.excluiPeriodo = function(row) {
        return Ger06700_FormaPagamento_Repository.excluiPeriodo(row);
    };
};
 Configuration(function (ContextRegister){
    ContextRegister.register('Ger06700_FormaPagamento_Service', Ger06700_FormaPagamento_Service);
});

// FILE: ./assets/js/services/Ger08300_banco_Service.js
function Ger08300_banco_Service(Ger08300_banco_Repository) {

	this.salvar = function(row){
			return Ger08300_banco_Repository.save(row);
	};
}
Configuration(function (ContextRegister) {
	ContextRegister.register('Ger08300_banco_Service', Ger08300_banco_Service);
});

// FILE: ./assets/js/services/Ger08500_ContaCorrente_Service.js
var Ger08500_ContaCorrente_Service = function(Ger08500_ContaCorrente_Repository){

	this.retornaFilial = function(){
		return Ger08500_ContaCorrente_Repository.retornaUnidadeLogada();
	};
	this.recalcularValorUtilizado = function(row){
		return Ger08500_ContaCorrente_Repository.recalculaValor(row);
	};
	this.validarContaCorrente = function(row){
		return Ger08500_ContaCorrente_Repository.validarContaCorrente(row);
	};
};
 Configuration(function (ContextRegister){
    ContextRegister.register('Ger08500_ContaCorrente_Service', Ger08500_ContaCorrente_Service);
});

// FILE: ./assets/js/services/Ger25940_TipoRecebimento_Service.js
var Ger25940_TipoRecebimento_Service = function(Ger25940_TipoRecebimento_Repository){

	this.validateDelete = function(widget){
        // var rows = Ger25940_TipoRecebimento_Repository.verificaRecebimentos();
        return Ger25940_TipoRecebimento_Repository.verificaRecebimentos().then(function(callback){
            var dataset = callback.dataset.tiporece_tiporece;
            var valida = false;
            for (var i = 0; i < dataset.length; i++) {
                if (widget.currentRow.CDTIPORECE == dataset[i].CDTIPOTROCO){
                    valida = true;
                }
            }
            if (valida) {
                return true;
            } else {
                return false;
            }
        });
    };
};
 Configuration(function (ContextRegister){
    ContextRegister.register('Ger25940_TipoRecebimento_Service', Ger25940_TipoRecebimento_Service);
});

// FILE: ./assets/js/services/rec41100_TipoContaReceber_Service.js
var rec41100_TipoContaReceber_Service = function(rec41100_TipoContaReceber_Repository) {
  
  this.getContctblMask = function() {
    return rec41100_TipoContaReceber_Repository.getContctblMask();
  };
  
  this.getNvMaxContctbl = function() {
    return rec41100_TipoContaReceber_Repository.getNvMaxContctbl();
  }; 
  
  
};

Configuration(function (ContextRegister) {
  ContextRegister.register('rec41100_TipoContaReceber_Service', rec41100_TipoContaReceber_Service);
});

// FILE: ./assets/js/controllers/Bco51100_TipodeDebitoBancario_Controller.js
var Bco51100_TipodeDebitoBancario_Controller = function(ZhFilterPreferences,ScreenService, templateManager,Bco51100_TipodeDebitoBancario_Service){

    this.findCompleteLevel = function (widget) {
        var verificaNivel = widget.getField('CDPICTCCTB').dataSource.data[0].CDPICTCCTB;
        verificaNivel = verificaNivel.split('.');
        verificaNivel = verificaNivel.length;
        widget.getField('CDCONTCTBL').dataSourceFilter[0].value = verificaNivel;
        widget.getField('CDCONTCTBL').reload();
    };
    
    this.codeAlreadyRegistered = function (widget) {
        Bco51100_TipodeDebitoBancario_Service.validarCodigo(widget.currentRow).then(
            null,
            function (error) {
				var errorMessage = 'Timeout';
				if (error.data) {
					errorMessage = error.data.error;
				}
				ScreenService.showMessage(errorMessage);
			}
        );
    }; 
    
    this.filter = function(widget){
        if(widget.appliedFilter){
            widget.appliedFilter.reload();
        }  
        ZhFilterPreferences.openFilterWidget(widget);
    };
    
};
Configuration(function (ContextRegister){
    ContextRegister.register('Bco51100_TipodeDebitoBancario_Controller', Bco51100_TipodeDebitoBancario_Controller);
});

// FILE: ./assets/js/controllers/Bco51200_TipoCreditoBancario_Controller.js
var Bco51200_TipoDeCreditoBancario_Controller = function(ZhFilterPreferences,ScreenService,Bco51200_TipoDeCreditoBancario_Service){

    this.findCompleteLevel = function (widget) {
        var verificaNivel = widget.getField('CDPICTCCTB').dataSource.data[0].CDPICTCCTB;
        verificaNivel = verificaNivel.split('.');
        verificaNivel = verificaNivel.length;
        widget.getField('CDCONTCTBL').dataSourceFilter[0].value = verificaNivel;
        widget.getField('CDCONTCTBL').reload();
    };
    
    this.codeAlreadyRegistered = function (widget) {
        Bco51200_TipoDeCreditoBancario_Service.validarCodigo(widget.currentRow).then(
            null,
            function (error) {
				var errorMessage = 'Timeout';
				if (error.data) {
					errorMessage = error.data.error;
				}
				ScreenService.showMessage(errorMessage);
				widget.currentRow.CDTPCREDBANC = "";
			}
        );
    }; 
    
};
Configuration(function (ContextRegister){
    ContextRegister.register('Bco51200_TipoDeCreditoBancario_Controller', Bco51200_TipoDeCreditoBancario_Controller);
});

// FILE: ./assets/js/controllers/Ger01600_IndiceFinanceiro_Controller.js
var Ger01600_IndiceFinanceiro_Controller = function(ZHPromise, ScreenService, General, Ger01600_IndiceFinanceiro_Service, templateManager) {

	var fieldDateForm = {
		"1" : {
			
			"template": "field/calendar.html",
			"separator" : "/",
            "displayFormat" : moment()._locale.longDateFormat('L'),
            "dateFormat" : "L",
            "datetime-preset": "date"
		},
		"2" : {
			
			"template": "field/select-month.html",
            "separator": "/",
            "displayFormat": "MM/YYYY",
            "dateFormat": "MM/YYYY",
            "datetime-preset": "date"
		},
		"3" : {			
			"template": "field/datetime.html",
            "separator": "/",
            "datetime-dateFormat": "yyyy",
            "datetime-dateOrder" : "yyyy",
            "datetime-preset": "date"
		}
	};

	var fieldDateView = {
		"1" : {
			"mask": {
            	"type": "dateFormat",
            	"params": {
            		"format": "DD/MM/YYYY HH:mm:ss",
            		"toFormat": "L"
            	}
            }
		},
		"2": {
			"mask": {
            	"type": "dateFormat",
            	"params": {
            		"format": "DD/MM/YYYY HH:mm:ss",
            		"toFormat": "MM/YYYY"
            	}
            }
		},
		"3" : {
			"mask": {
            	"type": "dateFormat",
            	"params": {
            		"format": "DD/MM/YYYY HH:mm:ss",
            		"toFormat": "YYYY"
            	}
            }
		}
	};

	var valueFormat = {
		"1" : {
			"label" : "Valor do Índice (%)"
		},
		"2" : {
			"label" : "Valor do Índice"
		}
	};
	
	var tipoData = { 
		"1" : {
			type: "Dias",
			format: "L"
		}, 
		"2" : {
			type: "Meses",
			format: "MM/YYYY"
		},
		"3" : {
			type: "Anos",
			format: "YYYY"
		}
	};
	
	this.back = function (widget) {
		var mode = widget.mode;

		ScreenService.closeSwipe().then(function () {
			if (mode == 'view') {
				widget.activate();
			} else if (mode == 'list') {
				widget.container.widgets[0].activate();
			}
		});
	};
	
	this.saveIndice = function(widget){
		var newCodeAntigo = widget.paramsNewCode.__new_code_pk;
		var columnsAntigo = widget.paramsNewCode.__columns_to_return[0];
		widget.paramsNewCode.__new_code_pk = widget.paramsNewCode.__new_code_pk + widget.currentRow.CDTPINDICE;
		widget.paramsNewCode.__columns_to_return[0] = widget.paramsNewCode.__new_code_pk;
		General.saveCrud(widget).then( 
			function(){
				widget.paramsNewCode.__new_code_pk = newCodeAntigo;
				widget.paramsNewCode.__columns_to_return[0] = columnsAntigo;
			}.bind(this)
		);
	};
	
	this.deleteIndice = function(widget){
		ScreenService.confirmMessage(ScreenService.i18n("CONFIRM_EXCLUSAO"), 'question', function (success) {
			Ger01600_IndiceFinanceiro_Service.deleteIndice(widget.currentRow).then(function(success){
				ScreenService.closeSwipe().then(function () {
					widget.activate();
					widget.reload();
				});
			}, function (error){
				ScreenService.showMessage(error.data.error);
			});
		});
	};
	
	this.habilitaWidgetFilha = function (widget, habilitar) {
		widget.isVisible = habilitar;
	};
	
	this.onEnterValoresTab = function (widgetFilha) {
		if (widgetFilha.mode == "list") {
			var widget = widgetFilha.getParent();

			var data = {
				CDTPINDICE : widget.currentRow.CDTPINDICE,
				IDPERVALOR : widget.currentRow.IDPERVALOR,
				CDINDICE : widget.currentRow.CDINDICE,
				NRORG : getLocalVar('NRORG')
			};

	 		General.buildDataSourceFilter(widgetFilha.dataSourceFilter, data);
	 		this.setDateViewMask(widgetFilha.getField('DTREFIND'), data.CDTPINDICE);
	 		this.setValueTemplate(widgetFilha.getField('VRINDICE'), data.IDPERVALOR);
	 		widgetFilha.reload();
		}
	};
	
	this.setDateViewMask = function(field, cdtpindice){
		for(var attr in fieldDateView[cdtpindice]) {
			delete field[attr];
			field[attr] = fieldDateView[cdtpindice][attr];
		}
		field.reload();
	};
	
	this.setDateFormTemplate = function (field, cdtpindice) {
		for(var attr in fieldDateForm[cdtpindice]) {
			delete field[attr];
			field[attr] = fieldDateForm[cdtpindice][attr];
		}
		field.reload();
	};
	
	this.setValueTemplate = function(field, idpervalor) {
		for(var attr in valueFormat[idpervalor]) {
			delete field[attr];
			field[attr] = valueFormat[idpervalor][attr];
		}
		field.reload();
	};
	
	this.addIndice = function(widget){
		widget.getField('IDPERVALOR').readOnly = false;
		widget.getField('SGINDICE').readOnly = false;
		widget.getField('CDTPINDICE').readOnly = false;
		this.habilitaWidgetFilha(widget.widgets[0], false);
		widget.newRow();
	};
	
	this.editIndice = function(widget){
		widget.getField('CDTPINDICE').readOnly = true;
		widget.getField('IDPERVALOR').readOnly = true;
		widget.getField('SGINDICE').readOnly = true;
		this.habilitaWidgetFilha(widget.widgets[0], false);
		General.edit(widget);
	};
	
	this.preencheValores = function(widget, widgetPai) {
		widget.currentRow.CDTPINDICE = widgetPai.currentRow.CDTPINDICE;
		widget.currentRow.CDINDICE   = widgetPai.currentRow.CDINDICE;
		widget.currentRow.IDPERVALOR = widgetPai.currentRow.IDPERVALOR;
	};
	
	this.addValue = function(widget) {
		widget.newRow();
		Ger01600_IndiceFinanceiro_Service.maxDtrefind(widget.dataSourceFilter).then(function(success){
			var maxDate = success.dataset.max_dtrefind[0].DTREFIND;
			var fieldDtrefind = widget.getField('formDTREFIND');
			fieldDtrefind.showOnForm = true;
			var cdtpindice = widget.dataSourceFilter[0].value;
			widget.getField('DTREFIND').showOnForm = false; 
			widget.currentRow.CDTPINDICE = cdtpindice;
			widget.currentRow.IDPERVALOR = widget.dataSourceFilter[1].value;
			widget.currentRow.CDINDICE = widget.dataSourceFilter[2].value;
			if(success.dataset.max_dtrefind[0].DTREFIND){
				maxDate = moment(maxDate, 'DD/MM/YYYY HH:mm:ss');
	 			widget.currentRow.formDTREFIND = maxDate.add(1, tipoData[cdtpindice].type).format(tipoData[cdtpindice].format);
				fieldDtrefind.readOnly = true;
			} else {
				fieldDtrefind.readOnly = false;
				maxDate = false;
	 			this.setDateFormTemplate(fieldDtrefind, cdtpindice);
	 			fieldDtrefind.validations.required = true;
			}
			fieldDtrefind.reload();
		}.bind(this));
	};
	
	this.editValue =function(widget) {
		var cdtpindice = widget.dataSourceFilter[0].value;
		var fieldDtrefind = widget.getField('formDTREFIND');
		fieldDtrefind.showOnForm = false;
		fieldDtrefind.validations = {};
		widget.getField('DTREFIND').showOnForm = true;
		this.setDateFormTemplate(fieldDtrefind, cdtpindice);
		widget.edit();
		fieldDtrefind.reload();
	};
	
	this.saveValue = function(widget) {
		var widgetPai = widget.getParent();
		var cdtpindice = widgetPai.currentRow.CDTPINDICE;
		if(widget.currentRow.__is_new) {
			var dataReferencia = widget.currentRow.formDTREFIND;
			dataReferencia = moment(dataReferencia,tipoData[cdtpindice].format).format('DD/MM/YYYY');
			widget.currentRow.DTREFIND = dataReferencia;
		}
		widget.currentRow.DTULTATUMVIN = moment().format('DD/MM/YYYY');
		this.preencheValores(widget, widgetPai);
		General.setFloatAttrOnCurrentRow(widget.currentRow, 'VRINDICE');
		General.saveCrud(widget);
	};
	
	this.deleteValue = function(widget){
		Ger01600_IndiceFinanceiro_Service.maxDtrefind(widget.dataSourceFilter).then(function(success){
			var maxDate = success.dataset.max_dtrefind[0].DTREFIND;
			var cdtpindice = widget.dataSourceFilter[0].value;
			maxDate = moment(maxDate, 'DD/MM/YYYY HH:mm:ss');
			var dtrefind = moment(widget.currentRow.DTREFIND, 'DD/MM/YYYY HH:mm:ss');
			if(maxDate.unix() == dtrefind.unix()) {
				widget.currentRow.DTREFIND = dtrefind.format('DD/MM/YYYY HH:mm:ss');
				General.deleteCrud(widget);
			} else {
				ScreenService.showMessage("Operação bloqueada. Somente a ultima data pode ser excluída.");
			}
		}.bind(this));
	};

	this.changeOperation = function(widget) {
		var oper = widget.currentRow.OPERACAO;
		var fields = [];
		fields.push(widget.getField('DTINICIAL'));
		fields.push(widget.getField('DTFINAL'));
		fields.push(widget.getField('VRINDICE'));
		this.cleanPopup(widget);

		switch (oper) {
			case "incluir" : this.includeAuto(widget, fields); break;
			case "editar" : this.editAuto(widget, fields); break;
			case "excluir" : this.excludeAuto(widget, fields); break;
		}
	};
	
	this.openAutoOperation = function(widget) {
		var promises = [];
		promises.push(Ger01600_IndiceFinanceiro_Service.maxDtrefind(widget.dataSourceFilter));
		promises.push(Ger01600_IndiceFinanceiro_Service.minDtrefind(widget.dataSourceFilter));
		var widgetCadastroAuto = widget.widgets[0];
		var cdtpindice = widget.dataSourceFilter[0].value;
		var idpervalor = widget.dataSourceFilter[1].value;
		var cdindice = widget.dataSourceFilter[2].value;
		widgetCadastroAuto.isVisible = true;
		widgetCadastroAuto.currentRow.cdtpindice = cdtpindice;
		widgetCadastroAuto.currentRow.idpervalor = idpervalor;
		widgetCadastroAuto.currentRow.cdindice = cdindice;

		this.setDateFormTemplate(widgetCadastroAuto.getField('DTINICIAL'), cdtpindice);
		this.setDateFormTemplate(widgetCadastroAuto.getField('DTFINAL'), cdtpindice);
		this.setValueTemplate(widgetCadastroAuto.getField('VRINDICE'), idpervalor);

		ZHPromise.all(promises).then(function(success) {
			var maxDate = success[0].dataset.max_dtrefind[0].DTREFIND;
			var minDate = success[1].dataset.min_dtrefind[0].DTREFIND;
			widgetCadastroAuto.currentRow.maxDate = maxDate;
			widgetCadastroAuto.currentRow.minDate = minDate;
			if(!maxDate) {
				widgetCadastroAuto.currentRow.OPERACAO = "incluir";
				widgetCadastroAuto.getField('OPERACAO').readOnly = true;
				widgetCadastroAuto.getField('OPERACAO').reload();
				this.changeOperation(widgetCadastroAuto);
			}
			ScreenService.openPopup(widgetCadastroAuto);

		}.bind(this));
	};

	this.editAuto = function(widget,fields){
		widget.getField('VRINDICE').validations = {"required": true};
		widget.currentRow.OPERACAO = "editar";
		widget.currentRow.__is_new = false;
		fields[0].readOnly = false;
		fields[1].readOnly = false;
		fields[2].readOnly = false; 

		var maxDate = moment(widget.currentRow.maxDate, "DD/MM/YYYY HH:mm:ss");
		var minDate = moment(widget.currentRow.minDate, "DD/MM/YYYY HH:mm:ss");
		
		widget.currentRow.DTINICIAL = minDate.format(tipoData[widget.currentRow.cdtpindice].format);
		widget.currentRow.DTFINAL = maxDate.format(tipoData[widget.currentRow.cdtpindice].format);

		if(fields[0].template == "field/datetime.html"){
			fields[0]["datetime-maxDate"] = maxDate.format("YYYY-MM-DD");
			fields[0]["datetime-minDate"] = minDate.format("YYYY-MM-DD");
			fields[1]["datetime-maxDate"] = maxDate.format("YYYY-MM-DD");
			fields[1]["datetime-minDate"] = minDate.format("YYYY-MM-DD");
		} else {
			fields[0].maxDate = widget.currentRow.DTFINAL;
			fields[0].minDate = widget.currentRow.DTINICIAL;
			fields[1].minDate = widget.currentRow.DTINICIAL;
			fields[1].maxDate = widget.currentRow.DTFINAL;
		}
		fields[0].reload();
		fields[1].reload();
		fields[2].reload();
		
		templateManager.updateTemplate();
	};
	
	this.includeAuto = function(widget,fields){
		widget.getField('VRINDICE').validations = {"required": true};
		widget.currentRow.OPERACAO = "incluir";
		widget.currentRow.__is_new = true;
		if(!widget.currentRow.maxDate) {
			fields[0].readOnly = false;
		} else {
			fields[0].readOnly = true;
		}
		fields[1].readOnly = false;
		fields[2].readOnly = false;

		var maxDate = !widget.currentRow.maxDate ? false : moment(widget.currentRow.maxDate, "DD/MM/YYYY HH:mm:ss");
		widget.currentRow.DTINICIAL = maxDate ? maxDate.add(1, tipoData[widget.currentRow.cdtpindice].type).format(tipoData[widget.currentRow.cdtpindice].format): "";
		widget.currentRow.DTFINAL = widget.currentRow.DTINICIAL;	
		if(fields[0].template == "field/datetime.html"){
			if(maxDate){
				fields[0]["datetime-maxDate"] = maxDate.format("YYYY-MM-DD");
				fields[0]["datetime-minDate"] = "1970-01-01";
				fields[1]["datetime-minDate"] = maxDate.format("YYYY-MM-DD");
				fields[1]["datetime-maxDate"] = "2050-01-01";
			}
		} else {
			fields[0].maxDate = widget.currentRow.DTFINAL;
			fields[0].minDate = "01/01/1970";
			fields[1].maxDate = "01/01/2050";
			fields[1].minDate = widget.currentRow.DTFINAL;
		}
		fields[0].reload();
		fields[1].reload();
		fields[2].reload();
		
		templateManager.updateTemplate();
	};
	
	this.excludeAuto = function(widget,fields){
		widget.getField('VRINDICE').validations = {};
		widget.currentRow.OPERACAO = "excluir";
		widget.currentRow.__is_new = false;
		fields[0].readOnly = false;
		fields[1].readOnly = true;
		fields[2].readOnly = true;

		var maxDate = moment(widget.currentRow.maxDate, "DD/MM/YYYY HH:mm:ss");
		widget.currentRow.DTFINAL = maxDate.format(tipoData[widget.currentRow.cdtpindice].format);
		var minDate = moment(widget.currentRow.minDate, "DD/MM/YYYY HH:mm:ss");
		widget.currentRow.DTINICIAL = minDate.format(tipoData[widget.currentRow.cdtpindice].format);
		
		if(fields[0].template == "field/datetime.html"){
			fields[0]["datetime-maxDate"] = maxDate.format("YYYY-MM-DD");
			fields[0]["datetime-minDate"] = minDate.format("YYYY-MM-DD");
			fields[1]["datetime-maxDate"] = "2050-01-01";
			fields[1]["datetime-minDate"] = "1970-01-01";
		} else {
			fields[0].maxDate = widget.currentRow.DTFINAL;
			fields[0].minDate = widget.currentRow.DTINICIAL;
			fields[1].maxDate = "01/01/2050";
			fields[1].minDate = "01/01/1970";
		}
		fields[0].reload();
		fields[1].reload();
		fields[2].reload();
		
		templateManager.updateTemplate();
	};
	
	this.cancelOperation = function(widget){
		ScreenService.closePopup();
		delete widget.getParent().currentWidget;
		widget.getParent().activate();
		this.cleanPopup(widget);
		widget.getField('OPERACAO').readOnly=false;
		widget.isVisible = false;
	};
	
	this.cleanPopup = function(widget){
		widget.getField('DTINICIAL').readOnly=true;
		widget.getField('DTFINAL').readOnly=true;
		widget.getField('VRINDICE').readOnly=true;
		widget.currentRow.DTFINAL = "";
		widget.currentRow.DTINICIAL = "";
		widget.currentRow.OPERACAO = "";
		widget.currentRow.VRINDICE = "";
		widget.currentRow.__is_new = false;
	};
	
	this.confirmOperation = function(widget){
		var dtIni = moment(widget.currentRow.DTINICIAL, tipoData[widget.currentRow.cdtpindice].format);
		var dtFim = moment(widget.currentRow.DTFINAL, tipoData[widget.currentRow.cdtpindice].format);
		
		if(dtFim.diff(dtIni,tipoData[widget.currentRow.cdtpindice].type) < 0){
			ScreenService.showMessage('Operação bloqueada. Data inicial não pode ser superior a data final');
			return 0;
		} else if(widget.isValid()) {
			var dataSave=[];
			var differenceDate = dtFim.diff(dtIni, tipoData[widget.currentRow.cdtpindice].type);
			var oper = widget.currentRow.OPERACAO;

			if (oper !== 'editar'){
				for(;differenceDate>=0; differenceDate--) {
					General.setFloatAttrOnCurrentRow(widget.currentRow, 'VRINDICE');
					var data = {
						__is_new : widget.currentRow.__is_new,
						CDTPINDICE : widget.currentRow.cdtpindice,
						CDINDICE : widget.currentRow.cdindice,
						IDPERVALOR : widget.currentRow.idpervalor,
						DTREFIND : dtIni.format("DD/MM/YYYY") + " 00:00:00",
						VRINDICE : widget.currentRow.VRINDICE
					};
					dataSave.push(data);
					dtIni.add(1, tipoData[widget.currentRow.cdtpindice].type);
				}
			}
			
			switch (oper) {
				case "editar"  : prepareEditAndDeleteOperations(widget, dtIni, differenceDate, dataSave);this.saveOperation(widget, dataSave); break;
				case "incluir" : this.saveOperation(widget, dataSave); break;
				case "excluir" : this.excludeOperation(widget, dataSave); break;
			}
		} else {
			ScreenService.showMessage("Preencha os campos obrigatórios!");
		}

	};
	
	function prepareEditAndDeleteOperations (widget, dtIni, differenceDate, dataSave){
		for(;differenceDate>=0; differenceDate--) {
				var exists = filterDatesToSave(widget.getParent().dataSource.data, dtIni);
				if (!Util.isEmptyOrBlank(exists)){
					General.setFloatAttrOnCurrentRow(widget.currentRow, 'VRINDICE');
					var data = {
						__is_new : widget.currentRow.__is_new,
						CDTPINDICE : widget.currentRow.cdtpindice,
						CDINDICE : widget.currentRow.cdindice,
						IDPERVALOR : widget.currentRow.idpervalor,
						DTREFIND : dtIni.format("DD/MM/YYYY")+" 00:00:00",
						VRINDICE : widget.currentRow.VRINDICE
					};
					dataSave.push(data);
				}
				dtIni.add(1, tipoData[widget.currentRow.cdtpindice].type);
			}
	}
	
	function filterDatesToSave (data, dtIni){
		return data.filter(function(row){
			return row.DTREFIND.substr(0,10) === dtIni.format("DD/MM/YYYY");
		});
	}
	
	this.saveOperation = function(widget, dataSave){
		Ger01600_IndiceFinanceiro_Service.saveMovindice(dataSave).then(function(success){
			widget.getParent().reload().then( function(){
				this.cancelOperation(widget);
			}.bind(this));
		}.bind(this), function(error){
			ScreenService.showMessage(error.data.error);
		});
	};
	
	this.excludeOperation = function(widget, dataSave){
		ScreenService.confirmMessage(ScreenService.i18n("CONFIRM_EXCLUSAO"), 'question', function (success) {
			Ger01600_IndiceFinanceiro_Service.deleteMovindice(dataSave).then(function(){
				widget.getParent().reload().then( function(){
					this.cancelOperation(widget);
				}.bind(this));
			}.bind(this));
		}.bind(this));
	};
	 
};
Configuration(function(ContextRegister) {
	ContextRegister.register("Ger01600_IndiceFinanceiro_Controller", Ger01600_IndiceFinanceiro_Controller);
});

// FILE: ./assets/js/controllers/Ger03000_historicoIntegracao_Controller.js
var Ger03000_historicoIntegracao_Controller = function(ScreenService, Ger03000_historicoIntegracao_Service){
	this.insertInit = function(){
		Ger03000_historicoIntegracao_Service.insertInit().then(undefined, function(error){
			ScreenService.showMessage(error.data.error);
		});
	};
};
Configuration(function (ContextRegister){
    ContextRegister.register('Ger03000_historicoIntegracao_Controller', Ger03000_historicoIntegracao_Controller);
}); 

// FILE: ./assets/js/controllers/Ger06700_FormaPagamento_Controller.js
var Ger06700_FormaPagamento_Controller = function(ScreenService, templateManager, General, Ger06700_FormaPagamento_Service){

    this.getFieldFromWidget  = function(widgetName, fieldName) {
        return General.getFieldValue(fieldName,widgetName);
    };
    
    this.flagToString = function(args){
        var arrayLength = args.owner.dataSource.data.length;
        if(arrayLength > 0){
            var campo = args.owner.dataSource.data[0].NRMESFORMPGT;
            if( campo < 11 ){
                args.owner.dataSource.data[0].NRMESFORMPGT = campo.toString();
                //args.owner.currentRow.NRMESFORMPGT = campo.toString();
            }
        }
    };
    
    this.setPeriodoPagamentoDataSourceFilter = function(){
        var widget = templateManager.container.getWidget('PeriodoPagamento');
        widget.dataSourceFilter = [
            {
                "name": "CDFORMPGTO",
                "operator": "=",
                "value": this.getFieldFromWidget('FormaPagamento', 'CDFORMPGTO')
            }
        ];
    };
    
    this.reload = function(){
        var widget = templateManager.container.getWidget('PeriodoPagamento');
        widget.reload();
    };
    
    this.flagToString2 = function(args){
        var campo = args.owner.widget.dataSource.data[0].NRMESFORMPGT;
        if(campo < 11 && campo){
            //args.owner.widget.dataSource.data[0].NRMESFORMPGT = campo.toString();
            args.owner.currentRow.NRMESFORMPGT = campo.toString();
        }
    };
    
    this.validaMinMaxDia = function(args, condition){
        var valueIni = args.row.NRDIAINIPGTO;
        var valueFin = args.row.NRDIAFINPGTO;
        var valuePag = args.row.NRDIAPGTOVAR;
        var mesPgt = args.row.NRMESFORMPGT;
        var diaPgt = args.row.NRDIAPGTOVAR;
        
        if(args.dataSource.length > 1){
            args.dataSource.forEach(
                function(row){
                    if(!row.__is_new){
                        if( (valueIni >= row.NRDIAINIPGTO) && (valueIni <= row.NRDIAFINPGTO) ){
                            ScreenService.showMessage('Dia Início do Período não pode coincidir com outros períodos de pagamento.');
                            args.row.NRDIAINIPGTO = '';
                        }
                        if( (valueFin >= row.NRDIAINIPGTO) && (valueFin <= row.NRDIAFINPGTO) ){
                            ScreenService.showMessage('Dia Final do Período não pode coincidir com outros períodos de pagamento.');
                            args.row.NRDIAFINPGTO = '';
                        }
                    }
                }      
            );
        }if(condition == "DI"){
            if(valueIni < '01' || valueIni > '31'){
                ScreenService.showMessage('Dia Início do Período deve estar entre 01 e 31.');
                args.row.NRDIAINIPGTO = '';
            }
        }else if(condition == "DF"){
            if(valueIni < '01' || valueFin > '31'){
                ScreenService.showMessage('Dia Final do Período deve estar entre 01 e 31.');
                args.row.NRDIAFINPGTO = '';
            }else if((mesPgt == '0') && (valueFin > diaPgt)){
                ScreenService.showMessage('Dia de Pagamento deve ser MAIOR ou IGUAL ao Dia Final do Período.');
                args.row.NRDIAPGTOVAR = '';
            }
        }else if(condition == "DP"){
            if(valueIni < '01' || valuePag > '31'){
                ScreenService.showMessage('Dia de Pagamento deve estar entre os dias 01 e 31.');
                args.row.NRDIAPGTOVAR = null;
            }else if((mesPgt == '0') && (valuePag < valueFin)){
                ScreenService.showMessage('Dia de Pagamento deve ser MAIOR ou IGUAL ao Dia Final do Período.');
                args.row.NRDIAPGTOVAR = null;
            }
        }
    };
    
    this.validaMaxSemanaMes = function(args){
        
        var tipoGrid = General.getFieldValue('IDTPPERIODO','FormaPagamento');
        
        if(tipoGrid == "A"){
            if(args.row.NRNUMMESPGTO < '01' || args.row.NRNUMMESPGTO > '04'){
                ScreenService.showMessage('Semana de pagamento deve estar entre 01 e 04.');
                args.row.NRNUMMESPGTO = '';
            }
        }else if(tipoGrid == "S"){
            if(args.row.NRNUMMESPGTO < '01' || args.row.NRMESFORMPGT > '04'){
                ScreenService.showMessage('Semana de pagamento deve estar entre 01 e 04.');
                args.row.NRMESFORMPGT = '';
            }
        }
    };
    
    this.teste = function(args){
        var widget = args.owner.owner.widget;
        widget.getField('NRMESFORMPGT').template = 'field/select-native.html';
        widget.getField('NRMESFORMPGT').dataSource.data = this.getData();
    };

    this.validaGridAtivo = function (args){
        
        var widget = args.owner;
        /*
        if(widget.name == "PeriodoPagamento"){
            if(widget.dataSource.data[0]){
                this.disableEnableNewRow(widget, false);
            }else{
                this.disableEnableNewRow(widget, true);
            }
        }*/

        var tipoGrid = General.getFieldValue('IDTPPERIODO','FormaPagamento');
  
        switch(tipoGrid) {
            case 'M':
                this.validaFieldsMes(widget);
                widget.getField('NRNUMMESPGTO').isVisible = true;
                widget.getField('NRDIAPGTOSEMANA').isVisible = true;
                widget.getField('NRMESFORMPGT').label = 'Mês de Pagamento';
                widget.getField('NRNUMMESPGTO').label = 'Número de Meses';
                break;
            case 'S':
                this.validaFieldsSemana(widget);
                widget.getField('NRNUMMESPGTO').isVisible = false;
                widget.getField('NRDIAPGTOSEMANA').isVisible = false;
                widget.getField('NRMESFORMPGT').label = 'Semana de Pagamento';
                break;
            case 'A':
                this.validaFieldsSemanaMes(widget);
                widget.getField('NRNUMMESPGTO').isVisible = true;
                widget.getField('NRDIAPGTOSEMANA').isVisible = false;
                widget.getField('NRMESFORMPGT').label = 'Mês de Pagamento';
                widget.getField('NRNUMMESPGTO').label = 'Semana de Pagamento';
                break;
            default:
        }
    };
    
    this.disableEnableNewRow = function(widget, flag){
        var newWidget = widget.container.getWidget('PeriodoPagamento');
        newWidget.getAction('add').isVisible = flag;
    };
    
    this.getSemana = function(){
        var diaSemana = [
            {
                "value": "01",
                "description": "Domingo"
            },
            {
                "value": "02",
                "description": "Segunda"
            },
            {
                "value": "03",
                "description": "Terça"
            },
            {
                "value": "04",
                "description": "Quarta"
            },
            {
                "value": "05",
                "description": "Quinta"
            },
            {
                "value": "06",
                "description": "Sexta"
            },
            {
                "value": "07",
                "description": "Sábado"
            }
        ];
        
        return diaSemana;
    };
    
    this.getData = function(){
        var data = [
            {
                "value": "0",
                "description": "Atual"
            },
            {
                "value": "1",
                "description": "Seguinte"
            }
        ];
        
        return data;
    };
    
    this.getMesPosterior = function(){
        var mesPosterior = [
            {
                "value": "1",
                "description": "1º Mês Posterior"
            },
            {
                "value": "2",
                "description": "2º Mês Posterior"
            },
            {
                "value": "3",
                "description": "3º Mês Posterior"
            },
            {
                "value": "4",
                "description": "4º Mês Posterior"
            },
            {
                "value": "5",
                "description": "5º Mês Posterior"
            },
            {
                "value": "6",
                "description": "6º Mês Posterior"
            },
            {
                "value": "7",
                "description": "7º Mês Posterior"
            },
            {
                "value": "8",
                "description": "8º Mês Posterior"
            },
            {
                "value": "9",
                "description": "9º Mês Posterior"
            },
            {
                "value": "10",
                "description": "10º Mês Posterior"
            }
        ];  
        
        return mesPosterior;
    };
    
    this.validaFieldsSemana = function(widget){
        widget.dataSource.data.forEach(function(data){
             data.NRMESFORMPGT = String(data.NRMESFORMPGT);
        });
        
        widget.getField('NRDIAINIPGTO').template = 'field/select-native.html';
        widget.getField('NRDIAINIPGTO').dataSource.data = this.getSemana();
        widget.getField('NRDIAFINPGTO').template = 'field/select-native.html';
        widget.getField('NRDIAFINPGTO').dataSource.data = this.getSemana();
        widget.getField('NRMESFORMPGT').template = 'field/select-native.html';
        widget.getField('NRMESFORMPGT').dataSource.data = this.getData();
        widget.getField('NRDIAPGTOVAR').template = 'field/select-native.html';
        widget.getField('NRDIAPGTOVAR').dataSource.data = this.getSemana();
    };
    
    this.validaFieldsSemanaMes = function(widget){
        widget.getField('NRDIAINIPGTO').template = 'field/text-edit.html';
        widget.getField('NRDIAINIPGTO').dataSource.data = [];
        widget.getField('NRDIAFINPGTO').template = 'field/text-edit.html';
        widget.getField('NRDIAFINPGTO').dataSource.data = [];
        widget.getField('NRMESFORMPGT').dataSource.data = this.getMesPosterior();
        widget.getField('NRDIAPGTOVAR').dataSource.data = this.getSemana();
    };

    this.validaFieldsMes = function(widget){
        
        widget.dataSource.data.forEach(function(data){
            data.NRMESFORMPGT = String(data.NRMESFORMPGT);
        });

        widget.getField('NRDIAINIPGTO').template = 'field/text-edit.html';
        widget.getField('NRDIAINIPGTO').dataSource.data = [];
        widget.getField('NRDIAFINPGTO').template = 'field/text-edit.html';
        widget.getField('NRDIAFINPGTO').dataSource.data = [];
        widget.getField('NRMESFORMPGT').template = 'field/select-native.html';
        widget.getField('NRMESFORMPGT').dataSource.data = this.getData();
        widget.getField('NRDIAPGTOVAR').template = 'field/text-edit.html';
        widget.getField('NRDIAPGTOVAR').dataSource.data = [];
        widget.getField('NRDIAPGTOSEMANA').template = 'field/select-native.html';
        widget.getField('NRDIAPGTOSEMANA').dataSource.data = this.getSemana();
        
    };
    
    this.ativaTab = function(widget){
        //this.disableEnableNewRow(widget, true);
        //if(widget.name == 'FormaPagamento'){
          //  widget.container.getWidget('PeriodoPagamento').activate();
        //}
    };
    
    this.salvarPeriodoPgto = function(args){
        var widget = args.owner.widget;
        if(!(widget.currentRow.__is_new)){
            var campo = widget.dataSource.data[widget.currentRow.__index].NRMESFORMPGT;
            widget.currentRow.NRMESFORMPGT = parseInt(campo, 10);
        }
        General.widgetSave(widget).then(function(){
            widget = args.owner.widget;
            if (widget.currentRow.__is_new) {
                widget.currentRow.__is_new = false;
            }else{
                 ScreenService.closeSwipe();
                 widget.reload();
            }
            var widget = templateManager.container.getWidget('FormaPagamento');
               //this.disableEnableNewRow(widget, false);
               // this.flagToString2(args);
        }.bind(this), function (error) {
            ScreenService.showMessage(error);
        });
    };
    
    this.confirmaExclusaoPeriodo = function(args){
        
        var cdformpgto = args.row.CDFORMPGTO;
        var nrorg = getLocalVar('NRORG');
        
        this.getPeriodo(cdformpgto, nrorg).then(function(diaPgto){
            if(diaPgto.dataset.diapgto[0]){
                ScreenService.confirmMessage("CONFIRM_DELETE", 'question', function() {
        
                    var row = {
                        "CDFORMPGTO": diaPgto.dataset.diapgto[0].CDFORMPGTO,
                        "NRDIAINIPGTO": diaPgto.dataset.diapgto[0].NRDIAINIPGTO,
                        "NRORG": nrorg
                    };
                     
                    this.excluiPeriodo(row).then(function(deletePeriodo){
                        //console.log('deleta lançamento Contabil');
                    });
        
                }.bind(this), function (error) {
                    ScreenService.showMessage(error);
                });
            }
        }.bind(this), function (error) {
            ScreenService.showMessage(error);
        });
    };
    
    this.deletaRegistro = function(args){
        General.deleteCrud(args.owner.widget).then(function (success){
            args.owner.widget.reload();
        });
    };
    
    this.getPeriodo = function(cdformpgto, nrdiainipgto, nrorg){
        return Ger06700_FormaPagamento_Service.getPeriodo(cdformpgto, nrdiainipgto, nrorg);
    };
    
    this.excluiPeriodo = function(row){
        return Ger06700_FormaPagamento_Service.excluiPeriodo(row);
    };
    
    this.salvarFormaPgto = function(args){
        var widget = args.owner.widget;
        General.widgetSave(widget).then(function(){
            General.changeWidgetAcessibility(args.owner.widget.widgets, true);
            args.owner.widget.reload();
        }.bind(this), function (error) {
            ScreenService.showMessage(error);
        });
    };
};
Configuration(function (ContextRegister){
    ContextRegister.register('Ger06700_FormaPagamento_Controller', Ger06700_FormaPagamento_Controller);
});

// FILE: ./assets/js/controllers/Ger08300_banco_Controller.js
var Ger08300_banco_Controller = function(Ger08300_banco_Service,General ,ScreenService, templateManager,ZhFilterPreferences){

    this.verificaCaracterIvalidoConta = function(){
        
       
        
        var mascara = templateManager.container.getWidget('grid_banco').getField('CDPICTCONT').value();
        var contNumero=0;
        for(var i = 0;i<mascara.length;i++){
            if(mascara.charAt(i)==9||mascara.charAt(i)=="-")
                contNumero++;
        }

        return contNumero<mascara.length;
    };
    
   this.verificacao = function(){
        
        var widget  = templateManager.container.getWidget('grid_banco');
        var digito  = widget.getField('CHKVERIFAGEN').value();
        var mascara = widget.getField('CDPICTAGEN').mask.params.mask;
        
        if(digito == "N"){
            widget.getField('CDPICTAGEN').mask.params.mask = "99999";
            widget.getField('CDPICTAGEN').setValue('');
        }else{
            widget.getField('CDPICTAGEN').mask.params.mask = "9999-9";
            widget.getField('CDPICTAGEN').setValue('');
        }

        widget.redraw();
        
    };
    
    this.verificaMascaraContaTraco = function(){
       
        var mascara = templateManager.container.getWidget('grid_banco').getField('CDPICTCONT').value();
        var cont_traco=0;
        for(var i = 0;i<mascara.length;i++){
            if(mascara.charAt(i)=="-")
                cont_traco++;
        }

        return cont_traco>1;
    };
    
    this.verificaMascaraAgenciaTraco = function(){
        
        var mascara = templateManager.container.getWidget('grid_banco').getField('CDPICTAGEN').value();
        var cont_traco=0;
        for(var i = 0;i<mascara.length;i++){
            if(mascara.charAt(i)=="-")
                cont_traco++;
        }

        return cont_traco>1;
    };
    
    this.verificaMascaraAgenciaNumero9 = function(){
       
        var mascara = templateManager.container.getWidget('grid_banco').getField('CDPICTAGEN').value();
        var contNumero=0;
        for(var i = 0;i<mascara.length;i++){
            if(mascara.charAt(i)==9)
                contNumero++;
        }
        return contNumero>5;
    };
    
     this.confirmaAdicionar = function(widget){
        
        widget.newRow();
        widget.getField('CDINSTCOBR').readOnly=false;
    };
    
    this.verificaCaracterIvalido = function(){
      
        var mascara = templateManager.container.getWidget('grid_banco').getField('CDPICTAGEN').value();
        var contNumero=0;
        for(var i = 0;i<mascara.length;i++){
            if(mascara.charAt(i)==9||mascara.charAt(i)=="-")
                contNumero++;
                console.log("mascara: "+mascara.charAt(i));
        }
        return contNumero<mascara.length;
    };
    
    this.verificaPosicaoTraco = function(){
       
        var mascara = templateManager.container.getWidget('grid_banco').getField('CDPICTAGEN').value();
        var traco;
        var length = mascara.length;
        for(var i = 0;i<mascara.length;i++){
            if(mascara.charAt(i)=="-")
                traco=true;
        }
        if(traco===true){
            if(mascara.charAt(length-2)=="-"){
                return false;
            }else  if(mascara.charAt(length-3)=="-"){
                return false;
            }else {
                return true;
            }
        }
        else{
            return false;
        }
    };
    
    this.habilitarWidget = function(){
        
        templateManager.container.getWidget('widget_cnab').enabled = true;
        templateManager.container.getWidget('grid_cobranca').enabled = true;
        templateManager.container.getWidget('FORMDDA').enabled = true;
    };
    
    this.desabilitarWidget = function(){
       
        //templateManager.container.getWidget('widget_cnab').enabled = false;
        //templateManager.container.getWidget('grid_cobranca').enabled = false;
        //templateManager.container.getWidget('FORMDDA').enabled = false;
    };
    
    this.setFiltroCnab = function(widget){
       
        if (!widget.isNewRow()){
            var current = widget.currentRow;
            var dadosEmpresa = templateManager.container.getWidget('dadosEmpresa');
            var ocorrenciaRetornoPagar = templateManager.container.getWidget('ocorrenciaRetornoPagar');
            var ocorrenciaRetornoReceber = templateManager.container.getWidget('ocorrenciaRetornoReceber');
            var instrucao = templateManager.container.getWidget('grid_cobranca');
            var filtro = current.CDBANCO;
            //dadosEmpresa.dataSourceFilter[0].value = filtro;
            //ocorrenciaRetornoPagar.dataSourceFilter[0].value = filtro;
            //ocorrenciaRetornoReceber.dataSourceFilter[0].value = filtro;
            templateManager.container.getWidget('dadosEmpresa').getField('CDINS1COBR').dataSourceFilter[0].value=filtro;
            templateManager.container.getWidget('dadosEmpresa').getField('CDINS2COBR').dataSourceFilter[0].value=filtro;
            templateManager.container.getWidget('dadosEmpresa').getField('CDINS1COBR').reload();
            templateManager.container.getWidget('dadosEmpresa').getField('CDINS2COBR').reload();
            var gridcontacorrente =templateManager.container.getWidget('grid_banco');
            cnab =current.CDBANCCNAB;
            if(cnab==341){
                templateManager.container.getWidget('dadosEmpresa').getField('IDLAYEXTBANCO').isVisible=true;
                templateManager.container.getWidget('dadosEmpresa').getField('IDLAYEXTBANCO').showOnForm=true;
                templateManager.container.getWidget('dadosEmpresa').getField('IDLAYEXTBANCO').showOnView=true;

                templateManager.container.getWidget('dadosEmpresa').getField('NMRAZSOCFORN').showOnForm=false;
                templateManager.container.getWidget('dadosEmpresa').getField('NMRAZSOCFORN').isVisible=false;
                templateManager.container.getWidget('dadosEmpresa').getField('NMRAZSOCFORN').showOnView=false;

                templateManager.container.getWidget('dadosEmpresa').getField('IDLAYOUTCNAB').isVisible=false;
                templateManager.container.getWidget('dadosEmpresa').getField('IDLAYOUTCNAB').showOnForm=false;
                templateManager.container.getWidget('dadosEmpresa').getField('IDLAYOUTCNAB').showOnView=false;

            }else{
                templateManager.container.getWidget('dadosEmpresa').getField('IDLAYEXTBANCO').isVisible=false;
                templateManager.container.getWidget('dadosEmpresa').getField('IDLAYEXTBANCO').showOnForm=false;
                templateManager.container.getWidget('dadosEmpresa').getField('IDLAYEXTBANCO').showOnView=false;


                templateManager.container.getWidget('dadosEmpresa').getField('IDLAYOUTCNAB').isVisible=false;
                templateManager.container.getWidget('dadosEmpresa').getField('IDLAYOUTCNAB').showOnForm=false;
                templateManager.container.getWidget('dadosEmpresa').getField('IDLAYOUTCNAB').showOnView=false;

                templateManager.container.getWidget('dadosEmpresa').getField('NMRAZSOCFORN').showOnForm=false;
                templateManager.container.getWidget('dadosEmpresa').getField('NMRAZSOCFORN').isVisible=false;
                templateManager.container.getWidget('dadosEmpresa').getField('NMRAZSOCFORN').showOnView=false;


            }if(cnab==399){
                templateManager.container.getWidget('dadosEmpresa').getField('IDLAYEXTBANCO').isVisible=false;
                templateManager.container.getWidget('dadosEmpresa').getField('IDLAYEXTBANCO').showOnForm=false;
                templateManager.container.getWidget('dadosEmpresa').getField('IDLAYEXTBANCO').showView=false;

                templateManager.container.getWidget('dadosEmpresa').getField('IDLAYOUTCNAB').isVisible=true;
                templateManager.container.getWidget('dadosEmpresa').getField('IDLAYOUTCNAB').showOnForm=true;
                templateManager.container.getWidget('dadosEmpresa').getField('IDLAYOUTCNAB').showOnView=true;

                templateManager.container.getWidget('dadosEmpresa').getField('NMRAZSOCFORN').showOnForm=true;
                templateManager.container.getWidget('dadosEmpresa').getField('NMRAZSOCFORN').isVisible=true;
                templateManager.container.getWidget('dadosEmpresa').getField('NMRAZSOCFORN').showOnView=true;
            }
        }
    };
    
    this.excluir = function(widget){
        
        General.deleteCrud(widget);
    };
    
    this.salvar = function(args){
        
        var Widget = args.owner.widget;
        if(this.verificaMascaraAgenciaNumero9()){
            ScreenService.showMessage('Máscara Agência inválida. Nº de caracteres válidos (9) deve ser menor ou igual a 5.');
        }
        else if(this.verificaMascaraAgenciaTraco()){
            ScreenService.showMessage('Máscara Agência inválida. Nº de caracteres válidos (-) deve ser menor ou igual a 1.');
        }
        else if(this.verificaCaracterIvalido()){
            ScreenService.showMessage('Máscara Agência inválida.Caracteres Inválidos');
        }
        else if(this.verificaPosicaoTraco()){
            ScreenService.showMessage('Máscara Agência inválida.Quantidade de dígitos de controle deve estar entre 1 e 2');
        }
        else if(this.verificaMascaraContaTraco()){
            ScreenService.showMessage('Máscara C/C inválida. Nº de caracteres válidos (-) deve ser menor ou igual a 1.');
        }
        else if(this.verificaCaracterIvalidoConta()){
            ScreenService.showMessage('Máscara  C/C inválida.Caracteres Inválidos');
        }

        else if(Widget.isValid()){
            General.saveCrud(Widget).then(function(Success) {
                ScreenService.showMessage('Salvo com sucesso!');
                var currentRow = Widget.currentRow;
                templateManager.container.getWidget('widget_cnab').enabled = true;
                templateManager.container.getWidget('grid_cobranca').enabled = true;
                templateManager.container.getWidget('FORMDDA').enabled = true;
            }, function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };
    
    this.salvarCNAB = function(args){
        var widget = args.owner.widget;
        templateManager.container.getWidget('dadosEmpresa').currentRow.CDBANCO=templateManager.container.getWidget('grid_banco').currentRow.CDBANCO;
        if(!widget.currentRow.IDLAYOUTCNAB){
            widget.currentRow.IDLAYOUTCNAB='240';
        }
        if(!widget.currentRow.IDLAYEXTBANCO){
            widget.currentRow.IDLAYEXTBANCO='200';
        }
        if(widget.isValid()){
            if(this.checkInstrucao(widget) == true){
                Ger08300_banco_Service.salvar(widget.currentRow).then(function() {
                    if (widget.currentRow.__is_new) {
                        widget.list(true);
                        ScreenService.goBack();
                    } else {
                        widget.view();
                    }
                    widget.activate();
                }, function(callback){
                        if(callback.data){
                            ScreenService.showMessage(callback.data.error);
                        }
                });
            }
        }
    };
     
     this.checkInstrucao =  function(widget){
        var widgetInst1 = widget.currentRow.CDINS1COBR;
        var widgetInst2 = widget.currentRow.CDINS2COBR;
        
        if((widgetInst2 == widgetInst1) && (widgetInst1) && (widgetInst2 )){
            ScreenService.showMessage('Erro. Instrução 1 igual à Instrução 2');
            return false;
        }
        return true;
    };
    
    this.salvarInstrucao = function(args){
        var Widget = args.owner.widget;
        templateManager.container.getWidget('grid_cobranca').currentRow.CDBANCO=templateManager.container.getWidget('grid_banco').currentRow.CDBANCO;
        General.saveCrud(Widget).then(function() {
            ScreenService.showMessage('Salvo com sucesso!');
        }, function(callback){
            if(callback.data){
                ScreenService.showMessage(callback.data.error);
            }
        });
    };
    
    this.cancelar = function(args){
        General.backOrCancel(args);
        this.habilitarWidget();
    };
    
    this.openFilterActionEvent = function() {
        var gridBanco = templateManager.container.getWidget('grid_banco');
        ZhFilterPreferences.openFilterWidget(gridBanco);
    };
    
    this.openFilterPopupWidgetOnEnter = function() {
        this.openFilterActionEvent();
    };
    
    this.setFieldsVisibleOnCNAB = function(widget){
        switch (widget.parent.parent.currentRow.CDBANCO) {
            case "341":
                widget.getField('IDPADRCNABPAG').isVisible = true;
                widget.getField('IDPADRCNABPAG').dataSource.data[0].name = 'SISPAG';
                widget.getField('IDPADRCNABPAG').dataSource.data[1].name = 'RISCO SACADO';
                widget.getField('IDPADRAGENCNABPAG').isVisible = false;
                widget.getField('IDLAYEXTBANCO').isVisible = true;
                widget.getField('IDLAYOUTCNAB').isVisible = false;
                widget.getField('IDPADRCNABREC').isVisible = false;
                break;
            case "237":
                widget.getField('IDPADRCNABPAG').isVisible = true;
                widget.getField('IDPADRCNABPAG').dataSource.data[0].name = 'PAGFORN';
                widget.getField('IDPADRCNABPAG').dataSource.data[1].name = 'MULTIPAG';
                widget.getField('IDPADRAGENCNABPAG').isVisible = true;
                widget.getField('IDLAYEXTBANCO').isVisible = false;
                widget.getField('IDLAYOUTCNAB').isVisible = false;
                widget.getField('IDPADRCNABREC').isVisible = false;
                break;
            case "399":
                widget.getField('IDPADRCNABPAG').isVisible = false;
                widget.getField('IDPADRAGENCNABPAG').isVisible = false;
                widget.getField('IDLAYEXTBANCO').isVisible = false;
                widget.getField('IDLAYOUTCNAB').isVisible = true;
                widget.getField('IDPADRCNABREC').isVisible = false;
                break;
            case "104":
                widget.getField('IDPADRCNABPAG').isVisible = false;
                widget.getField('IDPADRAGENCNABPAG').isVisible = false;
                widget.getField('IDLAYEXTBANCO').isVisible = false;
                widget.getField('IDLAYOUTCNAB').isVisible = false;
                widget.getField('IDPADRCNABREC').isVisible = true;
                break;
            default:
                widget.getField('IDPADRCNABPAG').isVisible = false;
                widget.getField('IDPADRAGENCNABPAG').isVisible = false;
                widget.getField('IDLAYEXTBANCO').isVisible = false;
                widget.getField('IDLAYOUTCNAB').isVisible = false;
                widget.getField('IDPADRCNABREC').isVisible = false;
                break;
            
        }
    };
    
    this.cancelaCadastroAutomaticoDDA = function (args){
        General.backOrCancel(args).then(function (){
            var widget = args.owner.widget;
            
            General.formWidgetSwitchTemplate(widget);
			General.changeWidgetAcessibility(widget.parent.widgets.concat(widget.parent), true);
        });
    };
    
    this.cadastraDDAAutomatico = function (widget){
        General.saveCrud(widget).then(function (){
            General.formWidgetSwitchTemplate(widget);
			General.changeWidgetAcessibility(widget.parent.widgets.concat(widget.parent), true);
        });
    };
    
    
};

Configuration(function (ContextRegister){
    ContextRegister.register('Ger08300_banco_Controller', Ger08300_banco_Controller);
});



// FILE: ./assets/js/controllers/Ger08400_Agencia_Controller.js
var Ger08400_Agencia_Controller = function(ScreenService, templateManager,General,Endereco){

    this.fieldEdicao = function(){
        templateManager.container.getWidget('contato').enabled = false;
        var grid_agencia =  templateManager.container.getWidget('grid_agencia');
        var pais = templateManager.container.getWidget('grid_agencia').getField('NMPAIS').value();
        var estado = templateManager.container.getWidget('grid_agencia').getField('NMESTADO').value();
        var municipio = templateManager.container.getWidget('grid_agencia').getField('NMMUNICIPIO').value();
        if(!pais){
            grid_agencia.getField('NMESTADO').readOnly = true;
            grid_agencia.getField('NMMUNICIPIO').readOnly = true;
            grid_agencia.getField('NMBAIRRO').readOnly = true;
        }
        else{
            if(!estado){
                grid_agencia.getField('NMESTADO').readOnly = false;
                grid_agencia.getField('NMMUNICIPIO').readOnly = true;
                grid_agencia.getField('NMBAIRRO').readOnly = true;
            }
            else{
                grid_agencia.getField('NMESTADO').readOnly = false;
                if(!municipio){
                    grid_agencia.getField('NMMUNICIPIO').readOnly = false;
                    grid_agencia.getField('NMBAIRRO').readOnly = true;

                }
                else{
                grid_agencia.getField('NMMUNICIPIO').readOnly = false;
                grid_agencia.getField('NMBAIRRO').readOnly = false;
                }
            }
        }
    };
    this.setAgencia = function(widget,args){
        var current= widget.currentRow;
        var gridWidget =  templateManager.container.getWidget('grid_agencia');
        gridWidget.getField('CDAGENCIA').mask.params = {'mask': current.CDPICTAGEN};
        //widget.currentRow.CDPICTAGEN ="";
    };

    this.setEstado = function(){
        var widget = templateManager.container.getActiveWidget();
        var cdpais = widget.getField('CDPAIS').value();
        widget.getField('NMESTADO').dataSourceFilter[0].value = cdpais;
        widget.getField('NMESTADO').readOnly= false;
        widget.getField('NMESTADO').reload();
    };

    this.setMunicipio = function(){
        var widget = templateManager.container.getActiveWidget();
        var cdpais = widget.getField('CDPAIS').value();
        var cdestado = widget.getField('SGESTADO').value();
        widget.getField('NMMUNICIPIO').dataSourceFilter[0].value = cdpais;
        widget.getField('NMMUNICIPIO').dataSourceFilter[1].value = cdestado;
        widget.getField('NMMUNICIPIO').readOnly= false;
        widget.getField('NMMUNICIPIO').reload();
    };

    this.setBairro = function(){
        var widget = templateManager.container.getActiveWidget();
        var cdestado = widget.getField('SGESTADO').value();
        var cdmunicipio = widget.getField('CDMUNICIPIO').value();
        var cdpais = widget.getField('CDPAIS').value();
        widget.getField('NMBAIRRO').dataSourceFilter[0].value = cdpais;
        widget.getField('NMBAIRRO').dataSourceFilter[1].value = cdestado;
        widget.getField('NMBAIRRO').dataSourceFilter[2].value = cdmunicipio;
        widget.getField('NMBAIRRO').readOnly= false;
        widget.getField('NMBAIRRO').reload();

    };

    this.limparValorPais = function(){
        var widget = templateManager.container.getActiveWidget();
        var pais = widget.getField('NMPAIS');
        if(pais.value()){
            widget.getField('NMESTADO').value("");
            widget.getField('NMMUNICIPIO').value("");
            widget.getField('NMBAIRRO').value("");
            widget.getField('SGESTADO').value("");
            widget.getField('CDBAIRRO').value("");
            widget.getField('CDMUNICIPIO').value("");
            widget.getField('NMESTADO').readOnly= false;
            widget.getField('NMMUNICIPIO').readOnly= true;
            widget.getField('NMBAIRRO').readOnly= true;
            widget.getField('NMESTADO').reload();
        }else{
            widget.getField('NMESTADO').value("");
            widget.getField('NMMUNICIPIO').value("");
            widget.getField('NMBAIRRO').value("");
            widget.getField('SGESTADO').value("");
            widget.getField('CDBAIRRO').value("");
            widget.getField('CDMUNICIPIO').value("");
            widget.getField('NMESTADO').readOnly= true;
            widget.getField('NMMUNICIPIO').readOnly= true;
            widget.getField('NMBAIRRO').readOnly= true;
            widget.getField('NMESTADO').reload();
        }
    };

    this.limparValorEstado= function(){
        var widget = templateManager.container.getActiveWidget();
        var estado = widget.getField('NMESTADO');
        if(estado.value()){
            widget.getField('NMMUNICIPIO').value("");
            widget.getField('NMBAIRRO').value("");
            widget.getField('CDBAIRRO').value("");
            widget.getField('CDMUNICIPIO').value("");
            widget.getField('NMMUNICIPIO').readOnly= false;
            widget.getField('NMBAIRRO').readOnly= true;
            widget.getField('NMMUNICIPIO').reload();
        }else{
            widget.getField('NMMUNICIPIO').value("");
            widget.getField('NMBAIRRO').value("");
            widget.getField('CDBAIRRO').value("");
            widget.getField('CDMUNICIPIO').value("");
            widget.getField('NMMUNICIPIO').readOnly= true;
            widget.getField('NMBAIRRO').readOnly= true;
            widget.getField('NMMUNICIPIO').reload();
        }
    };

    this.limparValorMunicipio = function(){
        var widget = templateManager.container.getActiveWidget();
        var municipio = widget.getField('NMMUNICIPIO');
        if(municipio.value()){
            widget.getField('NMBAIRRO').value("");
            widget.getField('CDBAIRRO').value("");
            widget.getField('NMBAIRRO').readOnly= false;
            widget.getField('NMBAIRRO').reload();
        }else{
            widget.getField('NMBAIRRO').value("");
            widget.getField('CDBAIRRO').value("");
            widget.getField('NMBAIRRO').readOnly= true;
            widget.getField('NMBAIRRO').reload();
        }
    };

    this.Adicionar = function(args){
        var widget = args.owner.widget;
        var filtro = widget.appliedFilter;
        templateManager.container.getWidget('contato').enabled = false;
        widget.newRow();
        widget.getField('CDAGENCIA').readOnly = false;
        widget.getField('NMESTADO').readOnly= true;
        widget.getField('NMMUNICIPIO').readOnly= true;
        widget.getField('NMBAIRRO').readOnly= true;
        if(!filtro.FILTER_ROW.NMBANCO){
            //args.owner.widget.getField('CDCONTCORR').mask.params = {'mask':''};
            args.owner.widget.getField('CDAGENCIA').readOnly = true;
            if(widget.dataSource.data){
                args.owner.widget.getField('CDAGENCIA').mask.params = {'mask':  widget.dataSource.data[0].CDPICTAGEN};
            }
        }
        else{
            //args.owner.widget.currentRow.CDBANCO= filtro.currentRow.CDBANCO;
            args.owner.widget.getField('CDAGENCIA').mask.params = {'mask':filtro.FILTER_ROW.CDPICTAGEN};
        }
    };

    this.excluirAgencia = function(widget){
        General.deleteCrud(widget);
    };

    this.salvarAgencia = function(args){
        var grid_agencia =  templateManager.container.getWidget('grid_agencia');
        var filterPopup = grid_agencia.appliedFilter;
        var widget = args.owner.widget;
        var cnpj = grid_agencia.currentRow.NRCGCAGEN;
        var agencia = grid_agencia.getField('CDAGENCIA').value();
        var telefone = grid_agencia.getField('NRFONEAGEN').value();
        var fax = grid_agencia.getField('NRFAXAGEN').value();

        grid_agencia.getField('CDAGENCIA').value(agencia.replace("-",""));
        if(telefone){
            grid_agencia.currentRow.NRFONEAGEN =grid_agencia.currentRow.NRFONEAGEN.replace(/[^0-9]/g,'');
        }
        if(fax){
            grid_agencia.currentRow.NRFAXAGEN =grid_agencia.currentRow.NRFAXAGEN.replace(/[^0-9]/g,'');
        }
        if(widget.currentRow.NRCEPAGEN){
            grid_agencia.currentRow.NRCEPAGEN =grid_agencia.currentRow.NRCEPAGEN.replace(/[^0-9]/g,'');
        }
        if(cnpj){
            grid_agencia.currentRow.NRCGCAGEN =grid_agencia.currentRow.NRCGCAGEN.replace(/[^0-9]/g,'');
        }
        General.saveCrud(widget).then(function(Success) {
            if(widget.currentRow.__is_new ===true && widget.currentRow.CDBANCO!==filterPopup.FILTER_ROW.CDBANCO){
                widget.reload();
            }
            templateManager.container.getWidget('contato').enabled = true;
        }, function(callback){
            if(callback.data){
                ScreenService.showMessage(callback.data.error);
            }
        });
    };

    this.salvarContato = function(args){
        var grid_agencia =  templateManager.container.getWidget('grid_agencia');
        var widget =args.owner.widget;
        if(widget.currentRow.__is_new){
            widget.currentRow.CDBANCO = grid_agencia.currentRow.CDBANCO;
            widget.currentRow.CDAGENCIA = grid_agencia.currentRow.CDAGENCIA;
            widget.currentRow.CDAGENCIA = widget.currentRow.CDAGENCIA.replace("-","");
        }
        if(widget.currentRow.NRFONECOAGEN){
            widget.currentRow.NRFONECOAGEN =widget.currentRow.NRFONECOAGEN.replace(/[^0-9]/g,'');
        }
        General.saveCrud(widget);
    };

    this.testGridFilterBeforeApply = function(args) {
        var grid_agencia =  templateManager.container.getWidget('grid_agencia');
        var filterPopup = grid_agencia.appliedFilter;
        if(filterPopup.isValid()){
            this.setAgencia(filterPopup,args);
        }
        
    };

    this.validarCepEnd = function(args) {

        var widget = args.owner.getParent().widget;
        var CEP = widget.currentRow.NRCEPAGEN;
        if(CEP){
            Endereco.buscarCep(CEP).then(
                function(response) {
                    var endereco = response.dataset.ENDERECO;
                    if(endereco) {
                        widget.currentRow.NRCEPAGEN = CEP;
                        widget.currentRow.CDPAIS = (endereco.CDPAIS)? endereco.CDPAIS : '';
                        widget.currentRow.NMPAIS = (endereco.NMPAIS)? endereco.NMPAIS : '';
                        widget.currentRow.SGESTADO = (endereco.SGESTADO)? endereco.SGESTADO : '';
                        widget.currentRow.NMESTADO = (endereco.NMESTADO)? endereco.NMESTADO : '';
                        widget.currentRow.CDMUNICIPIO = (endereco.CDMUNICIPIO)? endereco.CDMUNICIPIO : '';
                        widget.currentRow.NMMUNICIPIO = (endereco.NMMUNICIPIO)? endereco.NMMUNICIPIO : '';
                        widget.currentRow.CDBAIRRO = (endereco.CDBAIRRO)? endereco.CDBAIRRO : '';
                        widget.currentRow.NMBAIRRO = (endereco.NMBAIRRO)? endereco.NMBAIRRO : '';
                        widget.currentRow.DSENDEAGEN = (endereco.DSENDERECO)? endereco.DSENDERECO : '';
                        this.verificaFieldOnChangePais(endereco);
                    }
                    if(response.dataset.ERRO) ScreenService.showMessage(response.dataset.ERRO.MESSAGE, "warning");
                }.bind(this)
            );
        }
    };

    this.verificaFieldOnChangePais = function(endereco){
        var widget =templateManager.container.getWidget('grid_agencia');
        if(!endereco){
            widget.getField('NMPAIS').value('');
            widget.getField('CDPAIS').value('');


            widget.getField('NMESTADO').readOnly = true;
            widget.getField('NMESTADO').value('');
            widget.getField('SGESTADO').value('');


            widget.getField('NMMUNICIPIO').readOnly = true;
            widget.getField('NMMUNICIPIO').value('');
            widget.getField('CDMUNICIPIO').value('');

            widget.getField('NMBAIRRO').readOnly = true;
            widget.getField('NMBAIRRO').value('');
            widget.getField('CDBAIRRO').value('');
        }
        else{
            var pais = endereco.NMPAIS;
            var estado = endereco.NMESTADO;
            var municipio = endereco.NMMUNICIPIO;
            if(!pais){
            widget.getField('NMESTADO').readOnly = true;
            widget.getField('NMMUNICIPIO').readOnly = true;
            widget.getField('NMBAIRRO').readOnly = true;
            }
            else{
                if(!estado){
                    widget.getField('NMESTADO').readOnly = false;
                    widget.getField('NMMUNICIPIO').readOnly = true;
                    widget.getField('NMBAIRRO').readOnly = true;
                }
                else{
                    widget.getField('NMESTADO').readOnly = false;
                    if(!municipio){
                        widget.getField('NMMUNICIPIO').readOnly = false;
                        widget.getField('NMBAIRRO').readOnly = true;

                    }
                    else{
                    widget.getField('NMMUNICIPIO').readOnly = false;
                    widget.getField('NMBAIRRO').readOnly = false;
                    }
                }
            }
        }
    };

    this.verificaMascaraAgencia = function(args){
        var widget = args.owner.owner.widget;
        var field;
        if(widget.name=='filterPopup'){
            field = widget.getField('NMAGENCIA');
        }
        else{
            field = widget.getField('CDAGENCIA');
        }
        widget.currentRow.CDAGENCIA ='';
        if(!widget.currentRow.NMBANCO){
            field.readOnly=true;
            field.value("");
        }else{
            field.readOnly=false;
            field.value("");
            if(widget.name =='grid_agencia'){
                field.element.mask(widget.currentRow.CDPICTAGEN);
            }



        }
    };

    this.aplicarMascaraAgenciaFiltro = function(args){
        var widget = args.owner.owner.widget;
        var agencia = widget.getField('NMAGENCIA');
        agencia.fields[0].mask.params.mask = widget.currentRow.CDPICTAGEN;
        agencia.reload();
    };

    this.checkCPNJ = function(field) {
        var valid = General.validateCNPJ(field.value());
        if(!valid){
            ScreenService.showMessage("CNPJ informado está inválido.");
            field.value('');
        }
    }; 
    
    this.colocaMascara = function(){
        var widget = templateManager.container.getWidget('grid_agencia');
        var tamanhoPrimNivel, cdagencia;
        widget.dataSource.data.forEach(function(value){
            cdagencia = value.CDAGENCIA;
            if(value.CDPICTAGEN){
                if(value.CDPICTAGEN.indexOf("-") != -1){
                    tamanhoPrimNivel = value.CDPICTAGEN.split("-")[0].length;
                    value.CDAGENCIA = cdagencia.substring(0, tamanhoPrimNivel) + '-' + cdagencia.substring(tamanhoPrimNivel, cdagencia.length);
                }
            }
            widget.getField('CDAGENCIA').mask.params = {'mask': value.CDPICTAGEN};

        });
    };
    
    this.ajustaDataSourceFilter = function(){
        var widget = templateManager.container.getWidget('contato');
        if(widget.getParent().getField('CDAGENCIA').value())
            widget.dataSourceFilter[0].value = widget.getParent().getField('CDAGENCIA').value().replace("-","");
    };
    
    this.habilitaAgencia = function(){
          var widget = templateManager.container.getActiveWidget();
          if(widget.getField('NMBANCO').value()){
              widget.getField('NMAGENCIA').readOnly = false;
              widget.getField('NMAGENCIA').fields[0].mask.params.mask = widget.currentRow.CDPICTAGEN;
              widget.getField('NMAGENCIA').dataSourceFilter[0].value = widget.currentRow.CDBANCO;
          }else{
              widget.getField('NMAGENCIA').readOnly = true;
              widget.getField('NMAGENCIA').fields[0].mask.params.mask = "";
              widget.getField('NMAGENCIA').dataSourceFilter[0].value = "";
          }
          widget.currentRow.NMAGENCIA = "";
    };
    
    /**
     * Confirmar Edição
     */
    this.confirmaEditar = function(){
        var widget = templateManager.container.getWidget('grid_agencia');

        widget.getField('NMAGENCIA').focused = true;
        delete widget.getField('CDAGENCIA').focused;

    };
    
    /**
     * Confirmar Adição
     */
    this.confirmaAdicionar = function(){
        var widget = templateManager.container.getWidget('grid_agencia');

        widget.getField('CDAGENCIA').focused = true;
        delete widget.getField('NMAGENCIA').focused;

    };
};

Configuration(function (ContextRegister){
    ContextRegister.register('Ger08400_Agencia_Controller', Ger08400_Agencia_Controller);
});




// FILE: ./assets/js/controllers/Ger08500_ContaCorrente_Controller.js
var Ger08500_ContaCorrente_Controller = function(Ger08500_ContaCorrente_Service, ScreenService, templateManager, General, ZHPromise){
	
	var self = this;
	self.CAIXA_ECONOMICA_FEDERAL = '104';

	self.validacoesBanco = function(args){
		var widget = args.owner.field.widget;
		var field  = args.owner.field;
		
		self.setAgencia(widget);
		self.setDataSourceAgencia(widget);
		
		if(widget.name == "grid_contacorrente"){
			self.verificaMascaraCC(widget);
		}
	}; 
	
	self.setAgencia = function(widget){
 		widget.currentRow.NMAGENCIA = "";
 		
	 	if(widget.currentRow.NMBANCO){
	 		 widget.getField("NMAGENCIA").readOnly = false;
	 	}else widget.getField("NMAGENCIA").readOnly = true;
	 	
	 	if(widget.name == 'zhFilterPreferencesSelectConditions'){
 			widget.getField("CDREDUCONT").readOnly = true;
	 		widget.currentRow.CDREDUCONT = "";
	 	}
  	};
	
  	self.verificaMascaraCC = function(widget){
		if(widget.currentRow.NMBANCO){
			widget.getField('CDCONTCORR').readOnly = false;
			$('#CDCONTCORR').mask(widget.currentRow.CDPICTCONT);
		}else widget.getField('CDCONTCORR').readOnly = true;
		
  		widget.currentRow.CDCONTCORR = "";
  	};
	
	self.setDataSourceAgencia = function(widget){
   		widget.getField('NMAGENCIA').dataSourceFilter[0].value = widget.currentRow.CDBANCO;
	};

	self.verificaValidadorCnab = function(widget){
		var validadoresCnabImplementados = [self.CAIXA_ECONOMICA_FEDERAL];
		if (validadoresCnabImplementados.indexOf(widget.appliedFilter.FILTER_ROW.CDBANCO) >= 0){
			widget.getField('IDFASCNABREC').isVisible = true;
			widget.getField('IDFASCNABPAG').isVisible = true;
			widget.getField('CDOPERCONTCORR').isVisible = true;
		}else{
			widget.getField('IDFASCNABREC').isVisible = false;
			widget.getField('IDFASCNABPAG').isVisible = false;
			widget.getField('CDOPERCONTCORR').isVisible = false;
		}
	};
	
	self.validacoesAgencia = function(args){
		var widget = args.owner.field.widget;
		
	 	if(widget.name=='zhFilterPreferencesSelectConditions'){
	 		self.setContaCorrente(widget);
	 		self.setDataSourceContaCorrente(widget);
		}
	};

	self.setContaCorrente = function(widget){
	 	widget.currentRow.CDREDUCONT = "";
	 	
		if(!widget.currentRow.NMAGENCIA)
	 		 widget.getField("CDREDUCONT").readOnly = true;
	    else widget.getField("CDREDUCONT").readOnly = false;
	};

	self.setDataSourceContaCorrente = function(widget){
   		widget.getField('CDREDUCONT').dataSourceFilter[0].value = widget.currentRow.CDBANCO;
   		widget.getField('CDREDUCONT').dataSourceFilter[1].value = widget.currentRow.CDAGENCIA;
    };

	self.adicionar = function(args){
		var implantacaoSaldoForm = templateManager.container.getWidget('implantacaoSaldoForm');
		implantacaoSaldoForm.currentRow.CDREDUCONT = 0;
		implantacaoSaldoForm.currentRow.DTSDOCCORR = "";
		var widget = args.owner.widget;
		widget.newRow();
		templateManager.container.getWidget('grid_contas').isVisible = false;
		templateManager.container.getWidget('grid_limitecredito').isVisible = false;
		templateManager.container.getWidget('implantacaoSaldo').isVisible = false;
		templateManager.container.getWidget('implantacaoSaldoForm').isVisible = true;
		templateManager.container.getWidget('implantacaoSaldoForm').enabled = false;
		var filtro = widget.appliedFilter;
	 	widget.getField('NMEMPRESA').readOnly=false;
		widget.getField('CDCONTCORR').readOnly=false;
		widget.getField('CDREDUCONT').readOnly=false;
		widget.getField('NMBANCO').readOnly=false;
		
		self.geraCodigoReduzido().then(function(cdreducont_new){
			widget.currentRow.CDREDUCONT = cdreducont_new;
		
			if(!filtro.FILTER_ROW.NMBANCO){
				widget.getField('NMAGENCIA').readOnly=true;
				widget.getField('CDCONTCORR').readOnly = true;
				if(widget.dataSource.data){
					widget.getField('CDCONTCORR').mask.params = {'mask':  widget.dataSource.data[0].CDPICTCONT};
				}
	
			}
			else{
				widget.getField('NMAGENCIA').readOnly=false;
				widget.getField('NMAGENCIA').setValue(filtro.FILTER_ROW.NMAGENCIA);
				widget.getField('NMBANCO').setValue(filtro.FILTER_ROW.NMBANCO);
				widget.currentRow.CDAGENCIA= filtro.FILTER_ROW.CDAGENCIA;
				widget.currentRow.CDBANCO= filtro.FILTER_ROW.CDBANCO;
				widget.getField('CDCONTCORR').mask.params = {'mask':filtro.FILTER_ROW.CDPICTCONT};
	
			}
		});
 	};
 	
 	self.geraCodigoReduzido = function(){
 		var deferred = ZHPromise.defer();
 		
		General.callRestEngine('cadFin#/crud/contcorr', 'FilterData', []).then(function(contcorr){
			var contas = contcorr.dataset.contcorr;
			
			var cdreducont = [];
			contas.forEach(function(conta){
				cdreducont.push(conta.CDREDUCONT);
			});
			
			var cdreducont_new = '';
			
			while(cdreducont.includes(cdreducont_new) || !cdreducont_new){
 				cdreducont_new = Math.random().toString(36).substring(2, 5).toUpperCase();
			}
			
			deferred.resolve(cdreducont_new);
		});
		
		return deferred.promise;
 	};

 	self.codigoReduzidoOnchage= function(widget){
 		Ger08500_ContaCorrente_Service.validarContaCorrente(widget.currentRow).then(
 			null,
 			function (error) {
				var errorMessage = 'Timeout';
				if (error.data) {
					errorMessage = error.data.error;
				}
				ScreenService.showMessage(errorMessage);
				widget.currentRow.CDREDUCONT= "";
			}
 		);
 	};

  	self.editar = function(widget){
		widget.template = widget.templateToForm;
		General.edit(widget);
	};
	
	self.cancelar = function(widget){
		for (var i in widget.backupRow) {
			widget.currentRow[i] = widget.backupRow[i];
		}
		widget.template = widget.templateToView;
		widget.view();
	};
	
	self.aplicarFiltro = function(widget) {
      	self.setFiltro(widget);
  	};
	
	self.setFiltro = function(widget){
    	var current= widget.FILTER_ROW;
  		var gridWidget =  templateManager.container.getWidget('grid_contacorrente');
	  	gridWidget.getField('CDCONTCORR').mask.params = {'mask':  current.CDPICTCONT};
  	};
  	
  	self.setMascara = function(args){
  		var widget = templateManager.container.getActiveWidget();
	 	var current = widget.currentRow;
 		if(widget.name=='grid_contacorrente'){
 			widget.getField('CDCONTCORR').isVisible = false;
			widget.reload();
			widget.activate();
 			//widget.getField('CDCONTCORR').setValue("");
 			widget.currentRow.CDCONTCORR = "";
 		 	widget.getField('CDCONTCORR').mask.params = {'mask':  current.CDPICTCONT};
 			widget.getField('CDCONTCORR').isVisible = true;
 			widget.reload();
			widget.activate();
		}
  	};
    
  	self.desabilitarWidgetCC = function(){
		templateManager.container.getWidget('grid_contas').enabled = false;
		templateManager.container.getWidget('grid_limitecredito').enabled = false;
		templateManager.container.getWidget('implantacaoSaldo').enabled = false;
	};
	
	self.habilitarWidgetCC = function(){
		templateManager.container.getWidget('grid_contas').enabled = true;
		templateManager.container.getWidget('grid_limitecredito').enabled = true;
		templateManager.container.getWidget('implantacaoSaldo').enabled = true;
 	};
 	
 	self.desabilitarWidgetDados = function(){
		templateManager.container.getWidget('grid_contacorrente').enabled = false;
		templateManager.container.getWidget('grid_limitecredito').enabled = false;
		templateManager.container.getWidget('implantacaoSaldo').enabled = false;
	};
	
	self.habilitarWidgetDados = function(){
		templateManager.container.getWidget('grid_contacorrente').enabled = true;
		templateManager.container.getWidget('grid_limitecredito').enabled = true;
		templateManager.container.getWidget('implantacaoSaldo').enabled = true;
 	};
 	
 	self.desabilitarWidgetLimite = function(){
		templateManager.container.getWidget('grid_contacorrente').enabled = false;
		templateManager.container.getWidget('grid_contas').enabled = false;
		templateManager.container.getWidget('implantacaoSaldo').enabled = false;
	};
	
	self.habilitarWidgetLimite = function(){
		templateManager.container.getWidget('grid_contacorrente').enabled = true;
		templateManager.container.getWidget('grid_contas').enabled = true;
		templateManager.container.getWidget('implantacaoSaldo').enabled = true;
 	};
 	
 	self.excluirContaCorrente = function(widget){
		General.deleteCrud(widget);
	};
	
	self.cancelarContaCorrente = function(args){
		General.backOrCancel(args);
		self.habilitarWidgetCC();
		templateManager.container.getWidget('grid_contas').isVisible = true;
		templateManager.container.getWidget('grid_limitecredito').isVisible = true;
		templateManager.container.getWidget('implantacaoSaldo').isVisible = true;
		templateManager.container.getWidget('implantacaoSaldoForm').isVisible = false;
	};
	
	self.salvarContaCorrente = function(contaCorrente){
    	var implantacaoSaldoForm = templateManager.container.getWidget('implantacaoSaldoForm');
    	self.changeToUpperCaseCodReduzido(contaCorrente);
    	if(contaCorrente.isValid()){
    		if (contaCorrente.currentRow.__is_new){
    			var msg = 'Deseja realizar Implantação de Saldo?';
    			ScreenService.confirmMessage(msg, 'question',
        	        function() {
        	        	implantacaoSaldoForm.isVisible = true;
        	        	implantacaoSaldoForm.enabled = true;
        	        	implantacaoSaldoForm.edit();
        	            implantacaoSaldoForm.activate();
        	        },
        	        function(){
        	            self.confirmSaveContaCorrente(contaCorrente);
        	            ScreenService.showMessage("Registro Salvo Com Sucesso!");
        	        }
        	    );
    		}else{
    			self.confirmSaveContaCorrente(contaCorrente);
    			 
    		}

    	}
  	};

  	self.confirmSaveContaCorrente = function(widget){
  		if(widget.isValid()){
	  		var deferred = ZHPromise.defer();
			Ger08500_ContaCorrente_Service.retornaFilial().then(
	    			function(filial) {
			 			if(widget.currentRow.__is_new){
			 				var cdfilial = filial[0].CDFILIAL;
							widget.currentRow.CDFILIAL=cdfilial;
			 			}
						widget.currentRow.CDCONTCORR =widget.currentRow.CDCONTCORR.replace(/[^0-9]/g,'');
						widget.currentRow.VRSALDATUA= 0;
						
						var widgetImplantacaoSaldoForm = null;
						
						if(templateManager.container.getActiveWidget().name == 'implantacaoSaldoForm'){
							widgetImplantacaoSaldoForm = templateManager.container.getActiveWidget();
						}
						
						General.saveCrud(widget).then(
							function(){
								templateManager.container.getWidget('grid_contas').enabled = true;
								templateManager.container.getWidget('grid_limitecredito').enabled = true;
								templateManager.container.getWidget('implantacaoSaldo').enabled = true;
								templateManager.container.getWidget('grid_contas').isVisible = true;
								templateManager.container.getWidget('grid_limitecredito').isVisible = true;
								templateManager.container.getWidget('implantacaoSaldo').isVisible = true;
								templateManager.container.getWidget('implantacaoSaldoForm').isVisible = false;
								var filtro = widget.appliedFilter;
								var bancoFiltro = filtro.FILTER_ROW.CDBANCO;
								var agenciaFiltro = filtro.FILTER_ROW.CDAGENCIA;
								if( (bancoFiltro!==widget.currentRow.CDBANCO) || (agenciaFiltro!==widget.currentRow.CDAGENCIA)  ){
									widget.reload();
								}
								if(widgetImplantacaoSaldoForm){
									self.confirmSaveImplantacaoSaldo(widgetImplantacaoSaldoForm);
								}
							},
							function(callback){
								if(callback.data){
									ScreenService.showMessage(callback.data.error);
									}
						}
						
					);
				}
			).catch(
				function(callback){
					deferred.reject();
					if(callback.data){
						ScreenService.showMessage(callback.data.error);
					}
				}
			);
			
			return deferred.promise;
  		}
  	};

	self.setMascaraConta = function(widget){
		var gridWidget =  templateManager.container.getWidget('grid_contacorrente');
		gridWidget.getField('CDCONTCORR').mask.params = {'mask':  gridWidget.currentRow.CDPICTCONT};
	};
	
	self.salvarContaCC = function(args){
   		var Widget = args.owner.widget;
		if(Widget.currentRow.NRININOSNUMC>Widget.currentRow.NRFIMNOSNUMC){
			ScreenService.showMessage('Número inicial deve ser menor ou igual ao final');
		}
		else{
			General.saveCrud(Widget).then(function() {
				self.habilitarWidgetDados();
				Widget.list();
				Widget.template = Widget.templateToView;
				Widget.view();
			},
			function(callback){
				if(callback.data){
					ScreenService.showMessage(callback.data.error);
				}
			});
    	}
  	};
  	
	self.CheckBoxContaP = function(){
		var grid_contas = templateManager.container.getWidget('grid_contas');
		if(grid_contas.getField('IDVERFXNUMP').value()=="S"){
			grid_contas.getField('NRININOSNUMP').readOnly=false;
			grid_contas.getField('NRFIMNOSNUMP').readOnly=false;
			grid_contas.getField('NRININOSNUMP').validations.required = true;
			grid_contas.getField('NRFIMNOSNUMP').validations.required = true;
		}
		else{
			grid_contas.getField('NRININOSNUMP').readOnly=true;
			grid_contas.getField('NRFIMNOSNUMP').readOnly=true;
			grid_contas.currentRow.NRININOSNUMP = "";
			grid_contas.currentRow.NRFIMNOSNUMP = "";
			delete(grid_contas.getField('NRININOSNUMP').validations.required );
			delete(grid_contas.getField('NRFIMNOSNUMP').validations.required );
		}
  	};
  	
  	self.CheckBoxContaC = function(){
		var grid_contas = templateManager.container.getWidget('grid_contas');
		if(grid_contas.getField('IDVERFXNUMC').value()=="S"){
			grid_contas.getField('NRININOSNUMC').readOnly=false;
			grid_contas.getField('NRFIMNOSNUMC').readOnly=false;
			grid_contas.getField('NRININOSNUMC').validations.required = true;
			grid_contas.getField('NRFIMNOSNUMC').validations.required = true;
		}
		else{
			grid_contas.getField('NRININOSNUMC').readOnly=true;
			grid_contas.getField('NRFIMNOSNUMC').readOnly=true;
			grid_contas.currentRow.NRININOSNUMC = "";
			grid_contas.currentRow.NRFIMNOSNUMC = "";
			delete(grid_contas.getField('NRININOSNUMC').validations.required );
			delete(grid_contas.getField('NRFIMNOSNUMC').validations.required );
		}
  	};
  	
    self.CheckBoxControleCredito = function(){
 		var grid_limitecredito = templateManager.container.getWidget('grid_limitecredito');
 		if(grid_limitecredito.getField('IDCTRCREDCHQ').value()=="S"){
 			grid_limitecredito.getField('VRCTRCREDCHQ').readOnly=false;
			grid_limitecredito.getField('VRCTRCREDCHQ').validations.required = true;

		}
 		else{
 			grid_limitecredito.getField('VRCTRCREDCHQ').readOnly=true;
 			grid_limitecredito.getField('VRCTRCREDCHQ').setValue("");
 			delete(grid_limitecredito.getField('VRCTRCREDCHQ').validations.required );
 		}
 		templateManager.updateTemplate();
    };
    
 	self.CheckBoxControleCobranca = function(){
 		var grid_limitecredito = templateManager.container.getWidget('grid_limitecredito');
 		if(grid_limitecredito.getField('IDCTRCOBDESC').value()=="S"){
 			grid_limitecredito.getField('VRCTRCOBDESC').readOnly=false;
 			grid_limitecredito.getField('VRPERCOBDESC').readOnly=false;
 			grid_limitecredito.getField('VRCTRCOBDESC').validations.required = true;
			grid_limitecredito.getField('VRPERCOBDESC').validations.required = true;

		}
 		else{
 			grid_limitecredito.getField('VRCTRCOBDESC').readOnly=true;
 			grid_limitecredito.getField('VRPERCOBDESC').readOnly=true;
 			grid_limitecredito.getField('VRCTRCOBDESC').setValue("");
 			grid_limitecredito.getField('VRPERCOBDESC').setValue("");
 			delete(grid_limitecredito.getField('VRCTRCOBDESC').validations.required );
 			delete(grid_limitecredito.getField('VRPERCOBDESC').validations.required );
 		}
 		templateManager.updateTemplate();
    };
    
	self.salvarLimite = function(args){
    	var Widget = args.owner.widget;
		if(Widget.currentRow.VRPERCOBDESC<=100){
		    General.saveCrud(Widget).then(function() {
				self.habilitarWidgetLimite();
				Widget.list();
				Widget.template = Widget.templateToView;
				Widget.view();
				self.verficaVisibilidadeActionRecalcularValor(Widget);
			},
			function(callback){
				if(callback.data){
					ScreenService.showMessage(callback.data.error);
				}
			});
 	 	}else{
 	 		ScreenService.showMessage('Percentual de alerta não pode ser maior que 100%');
 	 	}
 	 };
 	 
  	self.WidgetOnEnter = function(args){
    		args.owner.currentRow = args.owner.dataSource.data[0];
	};
	
	self.recalcularValorUlizado = function(args){
		ScreenService.confirmMessage(ScreenService.i18n('Deseja recalcular o valor utilizado em cobrança descontada?'), 'question', function (success) {
			var widget = args.owner.widget;
			Ger08500_ContaCorrente_Service.recalcularValorUtilizado(widget.currentRow).then(function(Success) {
				if(Success.dataset.recalcular_valor_utiliado[0].VRCOBDESCONTO){
					widget.getField('VRUTLCOBDESC').setValue(Success.dataset.recalcular_valor_utiliado[0].VRCOBDESCONTO);
				}
				else{
					widget.getField('VRUTLCOBDESC').setValue('0');
				}
				widget.saveRow().then(function() {
					ScreenService.closePopup();
				},
				function(callback){
					if(callback.data){
						ScreenService.showMessage(callback.data.error);
					}
				});
			},function(callback){
				if(callback.data){
					ScreenService.showMessage(callback.data.error);
				}
			});
		}, function (error) {
		});
	};

	self.verficaVisibilidadeActionRecalcularValor = function (widget){
		var data = widget.dataSource.data[0];
		var recalcularValor = widget.getAction('recalcularValor');
		if(data){
			if(data.IDCTRCOBDESC=='S'){
				recalcularValor.readOnly = false;
			}else{
				recalcularValor.readOnly = true;
			}
		}

	};

	self.atualizaImplantacao = function(widget){
		var implantacao = templateManager.container.getWidget('implantacaoSaldo');
		self.setFiltroImplantacaoSaldo(widget, implantacao).then(function(){
			implantacao.reload();
		});
	};

	self.setFiltroImplantacaoSaldo = function(widget, implantacao){
		var deferred = ZHPromise.defer();
		implantacao.dataSourceFilter.forEach(function(filter){
			if (filter.name == 'CDREDUCONT'){
				filter.value = widget.currentRow.CDREDUCONT;
			}
		});
		deferred.resolve();
		return deferred.promise;
	};

	self.saveImplantacaoSaldo = function(implantacaoSaldo){
		var contaCorrente = templateManager.container.getWidget('grid_contacorrente');
		if (contaCorrente.currentRow.__is_new){
			self.confirmSaveContaCorrente(contaCorrente);
				ScreenService.showMessage('Registro salvo com sucesso.');
			
		}else{
			self.confirmSaveImplantacaoSaldo(implantacaoSaldo);
			
		}
	};

	self.confirmSaveImplantacaoSaldo = function(implantacaoSaldo){
		implantacaoSaldo.currentRow.CDREDUCONT = implantacaoSaldo.getParent().currentRow.CDREDUCONT;
		implantacaoSaldo.currentRow.VRSDOCCORR = 0;
		var row = implantacaoSaldo.currentRow;
		row.VRSDOIMPLA = self.formataValor(row.VRSDOIMPLA);
		var route = 'cadFin#/saveImplantacaoSaldo';
		General.callRestEngine(route, 'Row', row)
			.then(function(){
				ScreenService.closeSwipe();
				if (implantacaoSaldo.name == 'implantacaoSaldoForm'){
					implantacaoSaldo.isVisible = false;
					implantacaoSaldo.enabled = false;
				}
				templateManager.container.getWidget('grid_contas').enabled = true;
				templateManager.container.getWidget('grid_limitecredito').enabled = true;
				templateManager.container.getWidget('implantacaoSaldo').enabled = true;
				templateManager.container.getWidget('grid_contas').isVisible = true;
				templateManager.container.getWidget('grid_limitecredito').isVisible = true;
				templateManager.container.getWidget('implantacaoSaldo').isVisible = true;
				templateManager.container.getWidget('implantacaoSaldoForm').isVisible = false;
				implantacaoSaldo.reload();	
				}) 
			.catch(function(erro){
				ScreenService.showMessage(erro.data.error);
			});
	};

	self.excluiImplantacao = function(widget){
		ScreenService.confirmMessage('CONFIRM_EXCLUSAO', 'question', function() {
			var route = 'cadFin#/excluiImplantacaoSaldo';
			General.callRestEngine(route, 'Row', widget.currentRow)
			.then(function(){
				ScreenService.closeSwipe();
				widget.reload();
				ScreenService.showMessage('Registro excluído com sucesso.');
			})
			.catch(function(erro){
				ScreenService.showMessage(erro.data.error);
			});
		});
	};

	self.openEvolucaoSaldo = function(){
		var evolucaoSaldo = templateManager.container.getWidget('evolucaoSaldo');
		if (evolucaoSaldo.getParent()._hasCheckedRows()){
			ScreenService.openPopup(evolucaoSaldo).then(function(){
				evolucaoSaldo.isVisible = true;
			});
		}else{
			ScreenService.showMessage('Nenhuma conta selecionada para evolução.');
		}
	};

	self.evoluirSaldo = function(widget){
		if(widget.isValid()){
			var dataSet = [];
			var route = 'cadFin#/evolucaoSaldo';
			var dataInicial = widget.currentRow.DATAINICIAL;
			var contas = widget.getParent().getCheckedRows();
			contas.forEach(function(conta){
					var indice = dataSet.length;
	    	        dataSet[indice]={};
	    	        dataSet[indice].CDREDUCONT = conta.CDREDUCONT;
	    	        dataSet[indice].DATAINICIAL = dataInicial;
	    	    }
	        );
			General.callRestEngine(route, 'DataSet', dataSet)
			.then(function(){
				widget.isVisible = false;
				widget.getParent().unSelectAll();
				ScreenService.closePopup();
				ScreenService.showMessage('Saldo evoluído com sucesso.');
			})
			.catch(function(){
			});
		}

	};

	self.cancelarEvolucao = function(widget){
		ScreenService.closePopup();
		widget.isVisible = false;

	};
	
	self.filterAgencia = function (args){
		var widget = args.owner.field.widget;
		var row = args.row;
		widget.getField('NMAGENCIA').dataSourceFilter[0].value = row.CDBANCO;
	};
	
	self.changeToUpperCaseCodReduzido = function(widget) {
		widget.currentRow.CDREDUCONT = widget.currentRow.CDREDUCONT.toUpperCase(); 
	};
	
	self.formataValor = function(valor){
        if(typeof valor == 'string')
            if(valor.indexOf(',') >= 0)
                valor = valor.replace('.','').replace(',','.');
                
        valor = parseFloat(parseFloat(valor).toFixed(2));

        return valor;
    };
};
Configuration(function (ContextRegister){
    ContextRegister.register('Ger08500_ContaCorrente_Controller', Ger08500_ContaCorrente_Controller);
});

// FILE: ./assets/js/controllers/Ger25940_TipoRecebimento_Controller.js
var Ger25940_TipoRecebimento_Controller = function(ScreenService, General, Ger25940_TipoRecebimento_Service, templateManager){
    var CAMPOS = [ 
            ['NMINDICE', 'IDUTILVOUCHER', 'IDHABVENDAMAN'],
	    	['NMINDICE'],
	    	['NMINDICE', 'CDCREDENCCAR', 'CDBANCARTCR', 'CDADMINCART', 'CDBANCARTSEFAZ', 'IDMOSTRARECE', 'IDDESABTEF',
	    	 'IDSOLNSUCREDDEB', 'IDUTILVOUCHER'],
	    	['NMINDICE', 'CDCREDENCCAR', 'CDBANCARTCR', 'CDADMINCART', 'CDBANCARTSEFAZ', 'IDMOSTRARECE', 'IDDESABTEF',
	    	 'IDSOLNSUCREDDEB', 'IDUTILVOUCHER'],
	    	['NMINDICE', 'CDCREDENCCAR', 'CDBANCARTCR', 'CDBANCARTSEFAZ', 'IDMOSTRARECE', 'IDDESABTEF',
	    	 'IDSOLNSUCREDDEB', 'IDUTILVOUCHER'],
	    	['CDCREDENCCAR', 'CDBANCARTCR', 'CDADMINCART', 'CDBANCARTSEFAZ', 'IDMOSTRARECE', 'IDDESABTEF',
	    	 'IDSOLNSUCREDDEB', 'IDUTILVOUCHER', 'IDHABVENDAMAN'],
	    	['NMINDICE', 'CDCREDENCCAR', 'CDBANCARTCR', 'CDBANCARTSEFAZ', 'IDMOSTRARECE', 'IDDESABTEF',
	    	 'IDSOLNSUCREDDEB', 'IDUTILVOUCHER'],
	    	['NMINDICE', 'CDCREDENCCAR', 'CDBANCARTCR', 'CDBANCARTSEFAZ', 'IDMOSTRARECE', 'IDDESABTEF',
	    	 'IDSOLNSUCREDDEB', 'IDUTILVOUCHER', 'IDHABVENDAMAN'],
	    	['NMINDICE', 'CDCREDENCCAR', 'CDBANCARTCR', 'CDBANCARTSEFAZ', 'IDMOSTRARECE', 'IDDESABTEF',
	    	 'IDSOLNSUCREDDEB', 'IDUTILVOUCHER', 'IDHABVENDAMAN'],
	    	['NMINDICE', 'CDCREDENCCAR', 'CDBANCARTCR', 'CDBANCARTSEFAZ', 'IDMOSTRARECE', 'IDDESABTEF',
	    	 'IDSOLNSUCREDDEB', 'IDUTILVOUCHER', 'IDHABVENDAMAN'],
	    	['NMINDICE', 'CDCREDENCCAR', 'CDBANCARTCR', 'CDBANCARTSEFAZ', 'IDMOSTRARECE', 'IDDESABTEF',
	    	 'IDSOLNSUCREDDEB', 'IDUTILVOUCHER', 'IDHABVENDAMAN'],
	    	['NMINDICE', 'CDCREDENCCAR', 'CDBANCARTCR', 'CDBANCARTSEFAZ', 'IDMOSTRARECE', 'IDDESABTEF',
	    	 'IDSOLNSUCREDDEB', 'IDUTILVOUCHER', 'IDHABVENDAMAN']
	    ];
    var self = this; 

    var fieldSGESTADO = 'NMESTADO';
    
    var tipoRecebimento = function (){
        return templateManager.container.getWidget('ger25940_tipo_recebimento');
    };
    
    var widgetEndereco = function(){
      return templateManager.container.getWidget('ger25940_tipo_recebimento_endereco');
    };
    
    this.validacoesSelect = function(widget){
        if (widget.getField('IDTIPORECE').value() !== "6") {
            widget.getField('NMINDICE').readOnly = true;
            widget.getField('NMINDICE').setValue(null);
        } else {
            widget.getField('NMINDICE').readOnly = false;
        }
    };
    
    this.novoTipoRecebimento = function(widget){
        widget.newRow();
        self.validacoesSelect(widget);
    };
    
    var requireIndice = function (row){
        if(row == '6'){
            return {
                "required":true
            };
        }
        return {};
    };
    
    this.save = function(widget){
        widget.getField('NMINDICE').validations = requireIndice(widget.currentRow.IDTIPORECE);
        
        if(widget.isValid()){
            var ordensEmUso = widget.dataSource.data;
            var usada = false;
            for (var i = 0 ; i < ordensEmUso.length ; i++){
                if(ordensEmUso[i].NRORDTROCO == widget.currentRow.NRORDTROCO && ordensEmUso[i].CDTIPORECE !== widget.currentRow.CDTIPORECE) usada = true;
            }
            if (!usada){
                widget.saveRow().then(function(){
                    var currentRow = widget.currentRow;
                    if (currentRow.__is_new) {
                        widget.list();
                        ScreenService.goBack();
                    }else{
                        widget.view();
                    }
                    currentRow.__is_new = false;
                    currentRow.changed = false;
                    self.verificarValorFieldTipoRecebimento();
                    widget.activate();
                    widget.reload();
                }, function(calback){
                    ScreenService.showMessage(calback.data.error);
                });
            } else {
                ScreenService.showMessage("Ordem de troco já cadastrada");
            }
        }
    };
    
    this.delete = function(widget){
        Ger25940_TipoRecebimento_Service.validateDelete(widget).then(function(callback){
            if (callback) {
                ScreenService.showMessage('Não é Possivel excluir esse Registro, pois este possui Registro(s) Filho(s)');
            } else {
                General.deleteCrud(widget);
            }
        });
    };
    
    this.prepararCamposReadOnly = function () {
        var widget = tipoRecebimento();
        
        widget.fields.forEach(function(field){
            field.readOnly = false; 
        });
        
        widget.currentRow.NRORG = getLocalVar('NRORG');
        
        this.verificarValorFieldTipoRecebimento();
        
        this.verificarValorField(widget.getField('IDSOLIQTPARC'));
        
        this.editAdministradoraCartao(widget);
        
        
        var wid = widgetEndereco();
        wid.template = 'widget/form-view.html';
    	wid.view();
    	
        widget.activate();
    };
    
    this.verificarValorFieldTipoRecebimento = function () {
        var widget = tipoRecebimento();
        var field = widget.getField('IDTIPORECE');
        var valorCampo = field.value();
        
        if (valorCampo == 'A')
            valorCampo = 10;
        if (valorCampo == 'B')
            valorCampo = 11;
        if (valorCampo == 'C')
            valorCampo = 12;
        if (valorCampo == 'H')
            valorCampo = 4;

        var valoresAssociados = CAMPOS;
        var camposParaTroca = [];
        
        if((widget.mode == 'edit')){
            widgetEndereco().enabled = false;
        } else {
            widgetEndereco().enabled = (valorCampo == '1' || valorCampo == '2');
            templateManager.updateTemplate();
        }
        if(valorCampo)
            camposParaTroca = valoresAssociados[valorCampo-1];
        if(camposParaTroca)
            camposParaTroca.forEach(function(campo){
                widget.getField(campo).readOnly = true; 
            });
    };
    
    this.verificarValorField = function (field) {
        var widget = tipoRecebimento();
        var endereco = widgetEndereco();
        
        if (!field) {
            
            var fieldIDSOLIQTPARC = widget.getField('IDSOLIQTPARC');
            
            self.verificarValorField(fieldIDSOLIQTPARC);

            widget.__is_new =  endereco.currentRow.__is_new;
            
        } else {
            var nomeCampo = field.name;
            var valorCampo = field.value();
            widget = field.getParent();
            
            var camposAssociados = {
                "IDSOLIQTPARC": ['QTMAXPARC', 'VRMINPARC'],
                "SGESTADO": ['NMMUNICIPIO', "NMBAIRRO"],
                "NMMUNICIPIO": ['NMBAIRRO'],
                "NMPAIS": ['SGESTADO', 'NMMUNICIPIO', "NMBAIRRO"]
    	    };
    	    
    	     var camposParaTroca = [];
                
            switch (nomeCampo) {
                    case "IDSOLIQTPARC":
                        camposParaTroca = camposAssociados.IDSOLIQTPARC;
                        if(valorCampo == 'N') {
                            widget.getField('QTMAXPARC').value('');
                            widget.getField('VRMINPARC').value('');
                        }
                    break;
                    case fieldSGESTADO:
                        camposParaTroca = camposAssociados.SGESTADO;
                        if (!valorCampo) {
                            widget.getField('CDMUNICIPIO').value('');
                            widget.getField('NMMUNICIPIO').value('');
                        }
                    break;
                    case "NMMUNICIPIO":
                        camposParaTroca = camposAssociados.NMMUNICIPIO;
                        if (!valorCampo) {
                            widget.getField('NMBAIRRO').value('');
                            widget.getField('CDBAIRRO').value('');
                        }
                    break;
                     case "NMPAIS":
                        camposParaTroca = camposAssociados.NMMUNICIPIO;
                        if (!valorCampo) {
                            widget.getField('NMESTADO').value('');
                            widget.getField('NMESTADO').value('');
                            widget.getField('NMBAIRRO').value('');
                            widget.getField('CDBAIRRO').value('');
                            widget.getField('CDMUNICIPIO').value('');
                            widget.getField('NMMUNICIPIO').value('');
                        }
                    break;
            }
            
            if (field.template == 'field/select-native.html') {
                if (valorCampo == 'S') {
                    camposParaTroca.forEach(function(campo){
                        widget.getField(campo).readOnly = false;
                    });
                } else {
                    camposParaTroca.forEach(function(campo){
                        widget.getField(campo).readOnly = true;
                    });
                }
            } else {
                camposParaTroca.forEach(function(campo){
                    widget.getField(campo).readOnly = !field.value();
                });
                
            }
        }
    };
    
    this.editAdministradoraCartao = function(widget){
        if (!widget.currentRow.__is_new){
            
            widget = widgetEndereco();
            var wid = tipoRecebimento();
            widget.edit();
            widget.formTemplate = "widget/form.html";
            widget.template = "widget/form.html";
            
            this.changeFilter();
            
            widget.currentRow.IDTIPORECE = wid.currentRow.IDTIPORECE;
            widget.currentRow.NMTIPORECE = wid.currentRow.NMTIPORECE;
            widget.currentRow.CDTIPORECE = wid.currentRow.CDTIPORECE;

            }
    };
    
    this.changeFilter = function (field) {
        var widget = widgetEndereco();
        
        widget.getField(fieldSGESTADO).dataSourceFilter[1].value = widget.getField('CDPAIS').value();
        widget.getField('NMMUNICIPIO').dataSourceFilter[1].value = widget.currentRow.SGESTADO;
        widget.getField('NMBAIRRO').dataSourceFilter[2].value = widget.getField('CDMUNICIPIO').value();
        
        if(field) {
            if (field.name == 'NMPAIS') {
                widget.getField(fieldSGESTADO).value('');
                widget.getField('NMMUNICIPIO').value('');
                widget.getField('NMBAIRRO').value('');
            } else if (field.name == fieldSGESTADO) {
                widget.getField('NMMUNICIPIO').value('');
                widget.getField('NMBAIRRO').value('');
            }
        }
    };
    
    this.setDataIntoForm = function() {
        var widget = templateManager.container.getWidget('ger25940_tipo_recebimento_endereco');

        var data = widget.dataSource.data[0];
        
        if(data) {
            widget.getField('DSENDERECE').value(data.DSENDERECE);
            widget.getField('NRENDERECE').value(data.NRENDERECE);
            widget.getField('DSCOMPLERECE').value(data.DSCOMPLERECE);
            widget.getField('DSLOGRECE').value(data.DSLOGRECE);
            widget.getField('CDPAIS').value(data.CDPAIS);
            widget.getField('NMPAIS').value(data.NMPAIS);
            widget.getField(fieldSGESTADO).value(data.SGESTADO);
            widget.getField('CDMUNICIPIO').value(data.CDMUNICIPIO);
            widget.getField('NMMUNICIPIO').value(data.NMMUNICIPIO);
            widget.getField('NRCEPRECE').value(data.NRCEPRECE);
            widget.getField('CDBAIRRO').value(data.CDBAIRRO);
            widget.getField('NMBAIRRO').value(data.NMBAIRRO);
        }
    };
    
    this.saveEndereco = function (widget) {

        if (widget.isValid()){
            var currentRow = widget.currentRow;
            var wid = tipoRecebimento();
            widget.currentRow.__is_new = wid.currentRow.__is_new;
            
            if(currentRow.IDTIPORECE && currentRow.NMTIPORECE && currentRow.CDTIPORECE) {
                
                widget.saveRow().then(function(){
                    
                    if (widget.currentRow.__is_new) {
                        widget.template = 'widget/form-view.html';
    	                widget.view();
    	                
                        wid.currentRow.__is_new = false;
                        self.save(wid);
                        
                        ScreenService.closeSwipe().then(function() {
                            wid.activate().then(function(){
                                wid.reload().then(function(){
                                    wid.list();
                                });
                            });
                        });
                    } else {
                        self.viewAdministradoraCartao(widget);
                        currentRow.__is_new = false;
                        currentRow.changed = false;
                        widget.activate();
                        widget.reload();
                    }
                    
                }, function(calback){
                    ScreenService.showMessage(calback.data.error);
                });
            
            } else {
                wid.activate();
                wid.getField('CDTIPORECE').readOnly = false;
                ScreenService.showMessage("Preencha os campos: Código, Nome, Tipo de Recebimento e Ordem p/ Troco.");
            }
        }
    };
    
    this.viewAdministradoraCartao = function(widget) {
        widget.template = 'widget/form-view.html';
    	widget.view();
        widget.activate();
    };
    
    this.setDataSource = function(widget){
        widget.dataSourceFilter.forEach(function(data){
            if(data.name == 'NRORG'){
                data.value = getLocalVar('NRORG');
            }
            if(data.name == 'CDTIPORECE'){
                data.value = widget.getParent().currentRow.CDTIPORECE;
            }
        });
        General.callRestEngine('cadFin#/ger25940_tipo_recebimento_endereco', 'FilterData', widget.dataSourceFilter).then(function(success){
            widget.dataSource.data  = success.dataset.ger25940_tipo_recebimento_endereco;
            this.setFieldsAfterDataSource(widget);
        }.bind(this));
        widget.reload();
    };
    
    this.setFieldsAfterDataSource = function(widget){
        if(Object.keys(widget.currentRow).length > 0){
            widget.currentRow.CDBAIRRO = widget.dataSource.data[0].CDBAIRRO;
            widget.currentRow.CDMUNICIPIO = widget.dataSource.data[0].CDMUNICIPIO;
            widget.currentRow.CDPAIS = widget.dataSource.data[0].CDPAIS;
            widget.currentRow.CDTIPORECE = widget.dataSource.data[0].CDTIPORECE;
            widget.currentRow.DSCOMPLERECE = widget.dataSource.data[0].DSCOMPLERECE;
            widget.currentRow.DSENDERECE = widget.dataSource.data[0].DSENDERECE;
            widget.currentRow.DSLOGRECE = widget.dataSource.data[0].DSLOGRECE;
            widget.currentRow.NMBAIRRO = widget.dataSource.data[0].NMBAIRRO;
            widget.currentRow.NMESTADO = widget.dataSource.data[0].NMESTADO;
            widget.currentRow.NMMUNICIPIO = widget.dataSource.data[0].NMMUNICIPIO;
            widget.currentRow.NMPAIS = widget.dataSource.data[0].NMPAIS;
            widget.currentRow.NMTIPORECE = widget.dataSource.data[0].NMTIPORECE;
            widget.currentRow.NRCEPRECE = widget.dataSource.data[0].NRCEPRECE;
            widget.currentRow.NRENDERECE = widget.dataSource.data[0].NRENDERECE;
            widget.currentRow.NRORG = widget.dataSource.data[0].NRORG;
            widget.currentRow.SGESTADO = widget.dataSource.data[0].SGESTADO;
            widget.fields.forEach(function(fields){
                widget.getField(fields.name).reload();
            });
        }
    };
    
    this.validaPais = function(widget){
        if(widget.currentRow.NMPAIS == ""){
            widget.currentRow.NMESTADO = "";
            widget.currentRow.SGESTADO = "";
            widget.getField('NMESTADO').readOnly = true;
            widget.getField('NMESTADO').reload();
            widget.currentRow.NMMUNICIPIO = "";
            widget.currentRow.CDMUNICIPIO = "";
            widget.getField('NMMUNICIPIO').readOnly = true;
            widget.getField('NMMUNICIPIO').reload();
            widget.currentRow.CDBAIRRO = "";
            widget.currentRow.NMBAIRRO = "";
            widget.getField('NMBAIRRO').reload();
        } else {
            widget.getField('NMESTADO').readOnly = false;
            widget.getField('NMESTADO').reload();
        }
    };
    
    this.limpaEstado = function(widget){
        if(widget.currentRow.NMESTADO == ""){
            widget.currentRow.NMMUNICIPIO = "";
            widget.currentRow.CDMUNICIPIO = "";
            widget.getField('NMMUNICIPIO').readOnly = true;
            widget.getField('NMMUNICIPIO').reload();
            widget.currentRow.CDBAIRRO = "";
            widget.currentRow.NMBAIRRO = "";
            widget.getField('NMBAIRRO').readOnly = true;
            widget.getField('NMBAIRRO').reload();
        
        } else {
            widget.getField('NMMUNICIPIO').readOnly = false;
            widget.getField('NMMUNICIPIO').reload();
        }
    };
    
    this.limpaMunicipio = function(widget){
        if(widget.currentRow.NMMUNICIPIO == ""){
            widget.currentRow.CDBAIRRO = "";
            widget.currentRow.NMBAIRRO = "";
            widget.getField('NMBAIRRO').readOnly = true;
            widget.getField('NMBAIRRO').reload();
        } else {
            widget.getField('NMBAIRRO').readOnly = false;
            widget.getField('NMBAIRRO').reload();
        }
    };
    
    this.newRowOnEdit = function(widget){
        if(widget.currentRow.NMPAIS == ""){
            widget.getField('NMESTADO').readOnly = true;
            widget.getField('NMMUNICIPIO').readOnly = true;
            widget.getField('NMBAIRRO').readOnly = true;
            widget.getField('NMESTADO').reload();
            widget.getField('NMMUNICIPIO').reload();
            widget.getField('NMBAIRRO').reload();
        } else if ((widget.currentRow.NMPAIS != "") && (widget.currentRow.NMESTADO == "")){
            widget.getField('NMMUNICIPIO').readOnly = true;
            widget.getField('NMBAIRRO').readOnly = true;
            widget.getField('NMMUNICIPIO').reload();
            widget.getField('NMBAIRRO').reload();
        } else if((widget.currentRow.NMPAIS != "") && (widget.currentRow.NMESTADO != "") && (widget.currentRow.NMMUNICIPIO == "")){
            widget.getField('NMBAIRRO').readOnly = true;
            widget.getField('NMBAIRRO').reload();
        }
    };
    
    this.enabledParent = function(widget){
        widget.getParent().enabled = true;
    };
    
    this.disabledParent = function(widget){
        widget.getParent().enabled = false;
    };
    
};
Configuration(function (ContextRegister){
 ContextRegister.register('Ger25940_TipoRecebimento_Controller', Ger25940_TipoRecebimento_Controller);
});

// FILE: ./assets/js/controllers/Ger40100_Categorias_Dre_Gerencial_Controller.js
var ger40100_Categorias_Dre_Gerencial_Controller = function(ScreenService, templateManager, General, ZHPromise){
	
	var self = this;
	
	self.abreJanelaDRE = function(){
        var categorias_dre_grid   = templateManager.container.getWidget('categorias_dre_grid');
        var categorias_dre_tabbed = templateManager.container.getWidget('categorias_dre_tabbed');
        var categorias_dre_form   = templateManager.container.getWidget('categorias_dre_form');
        
        if(categorias_dre_grid.currentRow.TYPE == 'CA'){
            ScreenService.openSwipe(categorias_dre_tabbed).then(function(){
                
                categorias_dre_form.activate();
                
                categorias_dre_form.dataSourceFilter.forEach(function(filtro){
                    switch(filtro.name){
                        case 'NRORG'      : filtro.value = categorias_dre_grid.currentRow.NRORG;
                            break;
                        case 'CDITEMESTRU': filtro.value = categorias_dre_grid.currentRow.CDITEMESTRU;
                            break;
                    }
                }); 
                
                General.callRestEngine('cadFin#/crud/dregerestru', 'FilterData', categorias_dre_form.dataSourceFilter).then(function (result) {
                    var currentRow = result.dataset.dregerestru[0];
                    categorias_dre_form.currentRow = result.dataset.dregerestru[0];
                    
                    templateManager.updateTemplate();
                });
            });
        }else  ScreenService.goBack();
    };
	
	self.novaCategoriaDRE = function(){
        var categorias_dre_tabbed = templateManager.container.getWidget('categorias_dre_tabbed');
        ScreenService.openSwipe(categorias_dre_tabbed);
        categorias_dre_tabbed.showDescriptionOrder = false;
        
        var categorias_dre_form   = templateManager.container.getWidget('categorias_dre_form');
        General.widgetNewRow(categorias_dre_form);
        
        var classificacao_categorias_dre_grid   = templateManager.container.getWidget('classificacao_categorias_dre_grid');
        General.changeWidgetAcessibility([classificacao_categorias_dre_grid], false);
        
        templateManager.updateTemplate();
    };
    
    self.salvaCategoriaDRE = function(){
        var categorias_dre_grid   = templateManager.container.getWidget('categorias_dre_grid');
        var categorias_dre_tabbed = templateManager.container.getWidget('categorias_dre_tabbed');
        var categorias_dre_form   = templateManager.container.getWidget('categorias_dre_form');
        var classificacao_categorias_dre_grid = templateManager.container.getWidget('classificacao_categorias_dre_grid');
        
        General.saveCrud(categorias_dre_form).then(function(success) {
            
            if(categorias_dre_form.currentRow.__is_new){
                 categorias_dre_grid.activate();
                 categorias_dre_grid.reload();
            }else{
                categorias_dre_form.activate();
                categorias_dre_grid.currentRow.NAME = categorias_dre_form.currentRow.DSCTGESTRU;
            } 
            
            General.changeWidgetAcessibility([classificacao_categorias_dre_grid], true);
            categorias_dre_tabbed.showDescriptionOrder = true;
            
            templateManager.updateTemplate();
        });
    };
    
    self.editarCategoriaDRE = function(){
        var categorias_dre_form = templateManager.container.getWidget('categorias_dre_form');
        
		General.edit(categorias_dre_form);
		
		var classificacao_categorias_dre_grid   = templateManager.container.getWidget('classificacao_categorias_dre_grid');
        General.changeWidgetAcessibility([classificacao_categorias_dre_grid], false);
    };
    
    self.cancelaCategoriaDRE = function(args){
		var categorias_dre_tabbed = templateManager.container.getWidget('categorias_dre_tabbed');
		var classificacao_categorias_dre_grid   = templateManager.container.getWidget('classificacao_categorias_dre_grid');
		
        General.changeWidgetAcessibility([classificacao_categorias_dre_grid], true);
        categorias_dre_tabbed.showDescriptionOrder = true;
        
        General.backOrCancel(args);
    };
    
    self.excluiCategoriaDRE = function(){
        ScreenService.confirmMessage('Deseja realmente excluir a categoria?', 'question', function () {
            var categorias_dre_grid = templateManager.container.getWidget('categorias_dre_grid');
            var categorias_dre_form = templateManager.container.getWidget('categorias_dre_form');
            
    	    var route = 'cadFin#/removeCategoriaDRE';
            var type  = 'Row';
            var row   = categorias_dre_grid.currentRow;
            
            General.callRestEngine(route, type, row).then(function() {
                ScreenService.showMessage('Registro excluído com sucesso.');
                ScreenService.closeSwipe();
                
                categorias_dre_grid.reload();
                categorias_dre_grid.activate();
            }).catch(function(erro){
                ScreenService.showMessage(erro.data.error);
            });
        });
    };
    
    self.novaClassFinancCategoriaDRE = function(){
        var classificacao_categorias_dre_grid = templateManager.container.getWidget('classificacao_categorias_dre_grid');
        
		classificacao_categorias_dre_grid.newRow();
    };
    
    
    self.salvaClassFinancCategoriaDRE = function(){
        var classificacao_categorias_dre_grid = templateManager.container.getWidget('classificacao_categorias_dre_grid');
        
        var route = 'cadFin#/crud/classfinanc';
        var filter = [
            {
                "name": "CDCLASSFINA",
                "operator": "=",
                "value": classificacao_categorias_dre_grid.currentRow.CDCLASSFINA
            }
        ];
        General.callRestEngine(route, 'FilterData', filter).then(function(result) {
            var classfinanc = result.dataset.classfinanc[0];
            
            if(!classfinanc.CDITEMESTRU){
                self.confirmaClassFinancCategoriaDRE();
            }else{
                ScreenService.confirmMessage('Classificação financeira já associada a uma categoria. Deseja alterar para a selecionada?', 'question', function () {
                    self.confirmaClassFinancCategoriaDRE();
                });
            }
            
        });
    };
    
    self.confirmaClassFinancCategoriaDRE = function(){
        var classificacao_categorias_dre_grid = templateManager.container.getWidget('classificacao_categorias_dre_grid');
        
        var route = 'cadFin#/salvaClassFinancCategoriaDRE';
        var type  = 'Row';
        var row   = classificacao_categorias_dre_grid.currentRow;
        
        General.callRestEngine(route, type, row).then(function() {
            ScreenService.showMessage('Registro salvo com sucesso.');
            ScreenService.goBack().then(function() {
                classificacao_categorias_dre_grid.reload();
            });
        }).catch(function(erro){
            ScreenService.showMessage(erro.data.error);
        });
    };
    
    self.excluiClassFinancCategoriaDRE = function(){
        ScreenService.confirmMessage('Deseja realmente excluir a classificação financeira da categoria?', 'question', function () {
            var classificacao_categorias_dre_grid = templateManager.container.getWidget('classificacao_categorias_dre_grid');
            
            var route = 'cadFin#/excluiClassFinancCategoriaDRE';
            var type  = 'Row';
            var row   = classificacao_categorias_dre_grid.currentRow;
            
            General.callRestEngine(route, type, row).then(function() {
                ScreenService.showMessage('Registro excluído com sucesso.');
                ScreenService.goBack().then(function() {
                    classificacao_categorias_dre_grid.reload();
                });
            }).catch(function(erro){
                ScreenService.showMessage(erro.data.error);
            });
        });
    };
    
};

/* global Configuration */
Configuration(function (ContextRegister){
    ContextRegister.register('Ger40100_Categorias_Dre_Gerencial_Controller', ger40100_Categorias_Dre_Gerencial_Controller);
});

// FILE: ./assets/js/controllers/Pag41100_TipoContaPagar_Controller.js
var Pag41100_TipoContaPagar_Controller = function(ScreenService, templateManager,General){
	/**
	 * Função para a chamada da Action Salvar.
	 */
	var self = this;
	 
	this.configContctblField = function() {
      
      self.setContctblMask();
      self.setContctblFilter();
      
    };
    
	this.salvar = function(widget){
	    var cdtpctpagar = widget.currentRow.CDTPCTPAGAR;
	    cdtpctpagar = mascara(cdtpctpagar);
	    widget.currentRow.CDTPCTPAGAR = cdtpctpagar;
	    if (!widget.currentRow.hasOwnProperty('CDHISTPADR')){
	    	widget.currentRow.CDHISTPADR = '';
	    }
		General.saveCrud(widget).then(
            function(success){
               widget.reload();
            }, function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            }); 
	};
	
    
	this.editar = function(widget){
	    General.edit(widget);
	    widget.getField('IDCTBTPCNTBPAG').readOnly = true;
	    
	    
	    widget.getField('CDTPCTPAGAR').readOnly = true;
	    widget.getField('CDTPCTPAGAR').validations.required = false;
	};
	
	/**
	 * Função auxiliar para verificar se fields são numéricos.
	 */
	var isNumber = function(n) {
	    return !isNaN(parseFloat(n)) && isFinite(n);
	};
	
	/**
	 * Função auxiliar para aplicar máscara no código. 
	 */
	var mascara = function(codigo){
		if(codigo.length == 1){
			codigo = "00000".concat(codigo);
		}else{
			if(codigo.length == 2){
				codigo = "0000".concat(codigo);
			}else{
				if(codigo.length == 3){
					codigo = "000".concat(codigo);
				}else{
					if(codigo.length == 4){
						codigo = "00".concat(codigo);
					}else{
						if(codigo.length == 5)
							codigo = "0".concat(codigo);
					} 
				}
			}
		}
		return codigo;
	};
	 
	this.setContctblMask = function() {
        var contctblMask = getLocalVar('CDPICTCCTB');
        
        templateManager.container.getWidget('grid_conta').getField('CDCONTCTBL').mask.params.mask = contctblMask;
        templateManager.container.getWidget('grid_conta').getField('CDCONTCTBL').fields[0].mask.params.mask = contctblMask;
        
    
        
    }; 
    
     this.setContctblFilter = function() {
 
        General.callRestEngine('cadFin#/tipoctpagar_classfinanc_histpadr/nvmax_contctbl', 'FilterData', []).then(function(success){
            var NVMAXCONTCTBL = success.dataset.paramgeral.NVMAXCONTCTBL;
            templateManager.container.getWidget('grid_conta').getField('CDCONTCTBL').dataSourceFilter[0].value = NVMAXCONTCTBL;
        });
        //dataSourceFilter[0]: {name: "CDNVCONTCTBL", operator: "="}
    };
	 
	 /**
	  * Função que desabilita o Campo 'Contabiliza por Tipo de Conta na Baixa' e atribui o valor Não 
	  * como descrição, caso o Campo 'Contabiliza Lançamento' esteja com o valor Sim. Caso este último
	  * esteja com o valor Não, o primeiro é habilitado.
	  */
	this.contabizaOnChange = function(conta){
		var valueContLanc = conta.currentRow.IDCTBLCTPAG;
		if(valueContLanc == 'S'){
			conta.currentRow.IDCTBTPCNTBPAG = 'N';
			conta.getField('IDCTBTPCNTBPAG').readOnly = true;
		}else{
			conta.getField('IDCTBTPCNTBPAG').readOnly = false;
		}
	};
	
	 this.ajustaFiltro = function(preference) {
        var widget = templateManager.container.getWidget('grid_conta');
        widget.dataSourceFilter = [];
        if(preference.FILTER_ROW.CDTPCTPAGAR) {
            widget.dataSourceFilter.push({
                    "name": "CDTPCTPAGAR",
                    "operator": "=",
                    "value": "@General.getFieldValue('CDTPCTPAGAR','grid_conta',true) || null ;@"
            });
        }
        if(preference.FILTER_ROW.CDCONTCTBL) {
            widget.dataSourceFilter.push({
                    "name": "CDCONTCTBL",
                    "operator": "=",
                    "value": "@General.getFieldValue('CDCONTCTBL','grid_conta',true) || null ;@"
            });
        }
        if(preference.FILTER_ROW.DSCLASSFINA) {
             widget.dataSourceFilter.push({
                    "name": "CDCLASSFINA",
                    "operator": "=",
                    "value": "@General.getFieldValue('CDCLASSFINA','grid_conta',true) || null ;@"
            });
        }
    };
    
    this.configFloatingControl = function(field){
    	field.selectWidget.floatingControl.openSearch = false;
    };
    
    self.adicionarTituloEmpresa = function(widget){
        //var widgetTituloEmpresa = templateManager.container.getWidget('titulos_por_empresa');
        widget.getField('NMEMPRESA').template = 'field/select-multiple.html';
        templateManager.updateTemplate();
        widget.newRow();
         
    };
    
    self.salvarTituloEmpresa = function(){
        var widgetTipoConta = templateManager.container.getWidget('grid_conta');
        var widgetTituloEmpresa = templateManager.container.getWidget('titulos_por_empresa');
        widgetTituloEmpresa.currentRow.CDTPCTPAGAR = widgetTipoConta.currentRow.CDTPCTPAGAR;
        widgetTituloEmpresa.currentRow.NRORG = getLocalVar('NRORG');
        widgetTituloEmpresa.currentRow.CDOPERADOR = getLocalVar('CDOPERADOR');
        widgetTituloEmpresa.currentRow.DATA = moment().format('DD/MM/YYYY');
        General.callRestEngine('cadFin#/saveEmpresaPag','Row', widgetTituloEmpresa.currentRow).then(
           function(success){
                widgetTituloEmpresa.list();
                widgetTituloEmpresa.getField('NMEMPRESA').template = 'field/text-edit.html';
                widgetTituloEmpresa.reload();
               
           }, function(error){
               ScreenService.showMessage(error.dataset.error);
           });
    };
    
    self.abreCadastramentoAutomatico = function(){
        var widgetCadastramentoAutomatico = templateManager.container.getWidget('CadastramentoAutomaticoForm');
        widgetCadastramentoAutomatico.currentRow.IDOPERACAO = '';
        widgetCadastramentoAutomatico.currentRow.CDTPCTPAGAR = '';
        widgetCadastramentoAutomatico.currentRow.DSTPCTPAGAR = '';
        widgetCadastramentoAutomatico.currentRow.CDEMPRESA = '';
        widgetCadastramentoAutomatico.currentRow.NMEMPRESA = '';
        widgetCadastramentoAutomatico.isVisible = true;
        ScreenService.openPopup(widgetCadastramentoAutomatico);
    };
    
    self.reloadDataSoure = function(widget){
        widget.getField('DSTPCTPAGAR').reload();
    };
    
    self.questionCadastramentoAutomatico = function(widget){
        if(widget.currentRow.IDOPERACAO === 'S'){
            ScreenService.confirmMessage('Deseja realmente substituir o(s) tipo(s) de título a receber?', 'question', function () {
                self.geraCadastramentoAutomatico();
            });
        } else if(widget.currentRow.IDOPERACAO === 'I'){
            self.geraCadastramentoAutomatico();
        }
    };
    
    self.geraCadastramentoAutomatico = function(){
        var widgetTipoConta = templateManager.container.getWidget('grid_conta');
        var widgetTituloEmpresa = templateManager.container.getWidget('titulos_por_empresa');
        var CadastramentoAutomaticoForm = templateManager.container.getWidget('CadastramentoAutomaticoForm');
        CadastramentoAutomaticoForm.currentRow.NRORG = getLocalVar('NRORG');
        CadastramentoAutomaticoForm.currentRow.CDOPERADOR = getLocalVar('CDOPERADOR');
        CadastramentoAutomaticoForm.currentRow.DATA = moment().format('DD/MM/YYYY');
        General.callRestEngine('cadFin#/cadastroAutomaticoEmpresaPag','Row', CadastramentoAutomaticoForm.currentRow).then(
           function(success){
                ScreenService.closePopup();
                ScreenService.showMessage('Cadastro realizado com sucesso.');
                templateManager.container.getWidget('CadastramentoAutomaticoForm').isVisible = false;
                CadastramentoAutomaticoForm.currentRow = {};
                widgetTipoConta.reload();
                widgetTituloEmpresa.reload();
           }, function(error){
               ScreenService.showMessage(error.dataset.error);
           });
    };
    
	 
};

Configuration(function (ContextRegister){
    ContextRegister.register('Pag41100_TipoContaPagar_Controller', Pag41100_TipoContaPagar_Controller);
});

// FILE: ./assets/js/controllers/Pag43000_ParametrosContasPaga_Controller.js
var  Pag43000_ParametrosContasPaga_Controller = function(ScreenService, localStorageEngine){

    var self = this;

	var widget1;
	var widget2;

	self.setCampos = function(widgetTabbed){
		widget1 = widgetTabbed.widgets[0];
        var data = widget1.dataSource.data[0];
        if ( !data ){
            widget1.currentRow = {};
            widget1.currentRow.__is_new = true;
            widget1.currentRow.CDGERALPAG = '';
            widget1.currentRow.NRORG = '';
            widget1.currentRow.DSMULTAPAG = '';
            widget1.currentRow.DSMORAPAG = '';
            widget1.currentRow.DSCREPAG = '';
            widget1.currentRow.DSJUCTPAG = '';
            widget1.currentRow.NMANTAUTO = '';
            widget1.currentRow.DSUANTAUTO = '';
            widget1.currentRow.NMCREDCONT = '';
            widget1.currentRow.NMBAIXADOC = '';
            widget1.currentRow.NMBAIXATED = '';
            widget1.currentRow.IDUTLNFDEVOL = '';
            widget1.currentRow.DSTPCREDBANC = '';
            widget1.currentRow.IDHABIBOLE = 'N';
            widget1.currentRow.IDUTILPADRBOLHAB = 'N';
            widget1.currentRow.IDUTIAUTDESP = 'N';
            widget1.currentRow.IDEXTELACALAJUBX = 'N';
            widget1.currentRow.QTDIAANTBAIP = '';
            widget1.currentRow.QTDIAAPOBAIP = '';
            widget1.currentRow.QTDIAANTBOLP = '';
            widget1.currentRow.QTDIAAPOBOLP = '';
            widget1.currentRow.IDUTVISUBOLOPEL = 'N';
            widget1.currentRow.CDOPEPERVISUBOL = '';
        }else{
            widget1.currentRow = data;
            widget1.currentRow.__is_new = false;
            
            data.CDOPEPERVISUBOL_multi = data.CDOPEPERVISUBOL?data.CDOPEPERVISUBOL.split('_'):'';
            widget1.getField('CDOPEPERVISUBOL_multi').reload();
            widget1.redraw();
        }
		widget2 = widgetTabbed.widgets[1];
        widget2.currentRow = {};
        widget2.currentRow.QTDIAANTBAIP = widget1.currentRow.QTDIAANTBAIP;
        widget2.currentRow.QTDIAAPOBAIP = widget1.currentRow.QTDIAAPOBAIP;
        widget2.currentRow.QTDIAANTBOLP = widget1.currentRow.QTDIAANTBOLP;
        widget2.currentRow.QTDIAAPOBOLP = widget1.currentRow.QTDIAAPOBOLP;
	};

	self.salvar = function(param){
	    widget1.currentRow.CDOPEPERVISUBOL = widget1.currentRow.CDOPEPERVISUBOL_multi?widget1.currentRow.CDOPEPERVISUBOL_multi.join('_'):'';
	    
        if (widget1.currentRow.__is_new){
            this.setCurrentRow();
        }else{
            this.setIntervaloDatas();
        }
		widget1.saveRow().then(function(success){
			widget1.template = widget1.templateToView;
			widget1.view();
			widget2.template = widget2.templateToView;
			widget2.view();
            widget1.reload();
            widget2.reload();
			if (param){
				widget2.activate();
			} else {
				widget1.activate();
			}
			
			self.setCampos(widget1.getParent());
		},  function(callback){
			ScreenService.showMessage(callback.data.error);
		});
	};

    self.setIntervaloDatas = function(){
        widget1.currentRow.__is_new = false;
        widget1.currentRow.QTDIAANTBAIP = widget2.currentRow.QTDIAANTBAIP;
        parseInt(widget1.currentRow.QTDIAANTBAIP);
        widget1.currentRow.QTDIAAPOBAIP = widget2.currentRow.QTDIAAPOBAIP;
        parseInt(widget1.currentRow.QTDIAAPOBAIP);
        widget1.currentRow.QTDIAANTBOLP = widget2.currentRow.QTDIAANTBOLP;
        parseInt(widget1.currentRow.QTDIAANTBOLP);
        widget1.currentRow.QTDIAAPOBOLP = widget2.currentRow.QTDIAAPOBOLP;
        parseInt(widget1.currentRow.QTDIAAPOBOLP);
    };

    self.retornaOperadorLogado = function() {
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];
        return localStorageEngine.download("cadFin#/crud/operador", filter);
    };

    self.setCurrentRow = function(){
        var nrorg = null;
        this.retornaOperadorLogado().then(function(operador){
            nrorg = operador[0].NRORG;
        });
        widget1.currentRow = {};
        widget1.currentRow.__is_new = true;
        widget1.currentRow.CDGERALPAG = 1;
        widget1.currentRow.NRORG = nrorg;
        widget1.currentRow.DSMULTAPAG = '';
        widget1.currentRow.DSMORAPAG = '';
        widget1.currentRow.DSCREPAG = '';
        widget1.currentRow.DSJUCTPAG = '';
        widget1.currentRow.NMANTAUTO = '';
        widget1.currentRow.DSUANTAUTO = '';
        widget1.currentRow.NMCREDCONT = '';
        widget1.currentRow.NMBAIXADOC = '';
        widget1.currentRow.NMBAIXATED = '';
        widget1.currentRow.IDUTLNFDEVOL = '';
        widget1.currentRow.DSTPCREDBANC = '';
        widget1.currentRow.IDHABIBOLE = 'N';
        widget1.currentRow.IDUTILPADRBOLHAB = 'N';
        widget1.currentRow.IDUTIAUTDESP = 'N';
        widget1.currentRow.IDEXTELACALAJUBX = 'N';
        widget1.currentRow.QTDIAANTBAIP = '';
        widget1.currentRow.QTDIAAPOBAIP = '';
        widget1.currentRow.QTDIAANTBOLP = '';
        widget1.currentRow.QTDIAAPOBOLP = '';
        widget1.currentRow.IDUTVISUBOLOPEL = 'N';
        widget1.currentRow.CDOPEPERVISUBOL = '';
    };

	self.editar = function(){
		widget1.template = widget1.templateToForm;
		widget2.template = widget2.templateToForm;
		widget1.edit();
		widget2.edit();
		widget1.backupRow = (widget1.currentRow) ? Util.clone(widget1.currentRow): {};
		widget2.backupRow = (widget2.currentRow) ? Util.clone(widget2.currentRow): {};
	};

	self.cancelar = function(){
		widget1.currentRow = (widget1.currentRow) ? widget1.backupRow : null;
		widget1.template = widget1.templateToView;
		widget1.view();
		widget2.currentRow = (widget1.currentRow) ? widget2.backupRow : null;
		widget2.template = widget2.templateToView;
		widget2.view();
		
	};
 
};

Configuration(function(ContextRegister){
    ContextRegister.register('Pag43000_ParametrosContasPaga_Controller', Pag43000_ParametrosContasPaga_Controller);
});

// FILE: ./assets/js/controllers/rec41100_TipoContaReceber_Controller.js
var rec41100_TipoContaReceber_Controller = function(ScreenService, templateManager, General, rec41100_TipoContaReceber_Service ){
  
    var self = this;
  
    this.configContctblField = function() {
        // Substituido pelo local, a função não funciona;
        //self.setContctblMask();
        self.setContctblFilter();
    };
    
    /*this.setContctblMask = function() {
        rec41100_TipoContaReceber_Service.getContctblMask().then(function(response){
            var paramgeral = response.dataset.paramgeral[0];
            var contctblMask = paramgeral.CDPICTCCTB;
            var widget = templateManager.container.getWidget('rec41100_tipo_conta_receber');
            
            widget.getField('CDCONTCTBL').mask.params.mask = contctblMask;
            widget.getField('CDCONTCTBL').fields[0].mask.params.mask = contctblMask;
        });
    };*/ 
    
    self.adicionarTituloEmpresa = function(widget){
        //var widgetTituloEmpresa = templateManager.container.getWidget('titulos_por_empresa');
        widget.getField('NMEMPRESA').template = 'field/select-multiple.html';
        templateManager.updateTemplate();
        widget.newRow();
         
    };
    
    self.salvarTituloEmpresa = function(){
        var widgetTipoConta = templateManager.container.getWidget('rec41100_tipo_conta_receber');
        var widgetTituloEmpresa = templateManager.container.getWidget('titulos_por_empresa');
        widgetTituloEmpresa.currentRow.CDTPCTRECEB = widgetTipoConta.currentRow.CDTPCTRECEB;
        widgetTituloEmpresa.currentRow.NRORG = getLocalVar('NRORG');
        widgetTituloEmpresa.currentRow.CDOPERADOR = getLocalVar('CDOPERADOR');
        widgetTituloEmpresa.currentRow.DATA = moment().format('DD/MM/YYYY');
        General.callRestEngine('cadFin#/saveEmpresa','Row', widgetTituloEmpresa.currentRow).then(
           function(success){
                widgetTituloEmpresa.list();
                widgetTituloEmpresa.getField('NMEMPRESA').template = 'field/text-edit.html';
                widgetTituloEmpresa.reload();
               
           }, function(error){
               ScreenService.showMessage(error.dataset.error);
           });
    };
    
    
    this.setContctblFilter = function() {
      rec41100_TipoContaReceber_Service.getNvMaxContctbl().then(function(response) {
        var NVMAXCONTCTBL = response.dataset.paramgeral.NVMAXCONTCTBL;
        templateManager.container.getWidget('rec41100_tipo_conta_receber').getField('CDCONTCTBL').dataSourceFilter[0].value = NVMAXCONTCTBL;
      });
    };
    
    this.ajustaFiltro = function(widget, preference) {
        widget.dataSourceFilter = [];
        if(preference.FILTER_ROW.CDTPCTRECEB) {
            widget.dataSourceFilter.push({
                    "name": "CDTPCTRECEB",
                    "operator": "=",
                    "value": "@General.getFieldValue('CDTPCTRECEB','rec41100_tipo_conta_receber',true) || null ;@"
            });
        }
        if(preference.FILTER_ROW.CDCONTCTBL) {
            widget.dataSourceFilter.push({
                    "name": "CDCONTCTBL",
                    "operator": "=",
                    "value": "@General.getFieldValue('CDCONTCTBL','rec41100_tipo_conta_receber',true) || null ;@"
            });
        }
        if(preference.FILTER_ROW.DSCLASSFINA) {
             widget.dataSourceFilter.push({
                    "name": "CDCLASSFINA",
                    "operator": "=",
                    "value": "@General.getFieldValue('CDCLASSFINA','rec41100_tipo_conta_receber',true) || null ;@"
            });
        }
    };
    
    /**
     * Abre Cadastramento Automatico
     */
    self.abreCadastramentoAutomatico = function(){
        var widgetCadastramentoAutomatico = templateManager.container.getWidget('CadastramentoAutomaticoForm');
        widgetCadastramentoAutomatico.currentRow.CDTPCTRECEB = '';
        widgetCadastramentoAutomatico.currentRow.DSTPCTRECEB = '';
        widgetCadastramentoAutomatico.currentRow.CDEMPRESA = '';
        widgetCadastramentoAutomatico.currentRow.NMEMPRESA = '';
        widgetCadastramentoAutomatico.isVisible = true;
        ScreenService.openPopup(widgetCadastramentoAutomatico);
      
    };
    
    self.questionCadastramentoAutomatico = function(widget){
        if(widget.currentRow.IDOPERACAO === 'S'){
            ScreenService.confirmMessage('Deseja realmente substituir o(s) tipo(s) de título a receber?', 'question', function () {
                self.geraCadastramentoAutomatico();
            });
        } else if(widget.currentRow.IDOPERACAO === 'I'){
            self.geraCadastramentoAutomatico();
        }
    };
    
    self.geraCadastramentoAutomatico = function(){
        var widgetTipoConta = templateManager.container.getWidget('rec41100_tipo_conta_receber');
        var widgetTituloEmpresa = templateManager.container.getWidget('titulos_por_empresa');
        var CadastramentoAutomaticoForm = templateManager.container.getWidget('CadastramentoAutomaticoForm');
        CadastramentoAutomaticoForm.currentRow.NRORG = getLocalVar('NRORG');
        CadastramentoAutomaticoForm.currentRow.CDOPERADOR = getLocalVar('CDOPERADOR');
        CadastramentoAutomaticoForm.currentRow.DATA = moment().format('DD/MM/YYYY');
        General.callRestEngine('cadFin#/cadastroAutomaticoEmpresa','Row', CadastramentoAutomaticoForm.currentRow).then(
           function(success){
                ScreenService.closePopup();
                ScreenService.showMessage('Cadastro realizado com sucesso.');
                templateManager.container.getWidget('CadastramentoAutomaticoForm').isVisible = false;
                CadastramentoAutomaticoForm.currentRow = {};
                widgetTipoConta.reload();
                widgetTituloEmpresa.reload();
           }, function(error){
               ScreenService.showMessage(error.dataset.error);
           });
    };
    
};
Configuration(function (ContextRegister){
    ContextRegister.register('rec41100_TipoContaReceber_Controller', rec41100_TipoContaReceber_Controller);
});
