const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geral = new Helper.geral();
const loginPage = new Helper.login();
const protractorHelper = require('protractor-helper');
const j = require('../../../json/leitorJson.po');
const indiceFinanceiro = require('../../../page-objects/parametrizacao/financeiro/indiceFinanceiro.po');
describe('Índice Financeiro', () => {
    beforeEach(() => {
        browser.get('http://erpteste.teknisa.com/login/');
        loginPage.login(j.getValor('login'), j.getValor('senha'));
        indiceFinanceiro.abrir();
    });

    afterEach(() => {
        geral.sair();
    });
    it('Acessar tela de Indice Financeiro', () => {
        expect(z.component.header.getTitle()).toBe('Índice Financeiro');
    });
    it('Realizar o preenchimento dos campos solicitados na página', () => {
        protractorHelper.waitForElementVisibility(element(by.id('grid-1498425375535442543180')));
        geral.clickAdicionar();
        indiceFinanceiro.adicionar(j.getValor('sigla'), j.getValor('nome'), j.getValor('percentual'),
            j.getValor('tipoDeIndice'));
        geral.clickSalvar();
        geral.filterIt(j.getValor('nome'));
        expect(geral.gridHasText('1498425375535442543180', j.getValor('nome'), 1)).toBe(j.getValor('nome'));
    });
    it('Editar Registro', () => {
        protractorHelper.waitForElementVisibility(element(by.id('grid-1498425375535442543180')));
        geral.filterIt(j.getValor('nome'));
        geral.clickGrid('NMINDICE', j.getValor('nome'), '1498425375535442543180');
        z.component.footer.clickCenterActionByLabel('Alterar');
        indiceFinanceiro.editar(j.getValor('nome1'));
        geral.clickSalvar();
        geral.clickVoltar();
        geral.filterIt(j.getValor('nome1'));
        expect(geral.gridHasText('1498425375535442543180', j.getValor('nome1'), 1)).toBe(j.getValor('nome1'));
    });
    it('Excluir Registro', () => {
        protractorHelper.waitForElementVisibility(element(by.id('grid-1498425375535442543180')));
        geral.filterIt(j.getValor('nome1'));
        geral.clickGrid('NMINDICE', j.getValor('nome1'), '1498425375535442543180');
        geral.clickExcluir();
        geral.clickSim();
        geral.filterIt(j.getValor('nome1'));
        expect(geral.gridHasText('1498425375535442543180', j.getValor('nome1'), 1)).toBeUndefined();
    }
    );
});
